#include "ClipFilter.h"

const QPixmap& ClipFilter::getResault() const
{
    return myPixmap;
}

void ClipFilter::setPixmap(const QPixmap& sourcePixmap)
{
    myImage = new QImage(sourcePixmap.toImage()
                         .convertToFormat(QImage::Format_ARGB32));
    mySelector->setImageWidth(myImage->width());
    mySelector->setImageHeight(myImage->height());
    mySelector->show();
}

void ClipFilter::threadFinished()
{
    myPixmap = QPixmap::fromImage(*myImage);
    delete myThread;
    myThread = NULL;
    emit finished();
}

void ClipFilter::cancelCliked()
{
    mySelector->close();
    emit canceled();
}

void ClipFilter::pathClicked(QList<QPainterPath> path)
{
    myThread = new ClipThread(myImage,path);
    mySelector->close();
    emit blockInput();
    connect(myThread,SIGNAL(finished()),this,SLOT(threadFinished()));
    myThread->start();
}

ClipFilter::ClipFilter()
{
    myThread = NULL;
    mySelector = new PathSelector;
    connect(mySelector,SIGNAL(cancel()),this,SLOT(cancelCliked()));
    connect(mySelector,SIGNAL(pathSelected(QList<QPainterPath>)),
            this,SLOT(pathClicked(QList<QPainterPath>)));
}

ClipFilter::~ClipFilter()
{
    if(myThread != NULL)
    {
        myThread->terminate();
        delete myThread;
    }
    delete mySelector;
}
