#ifndef CLIPFILTER_H
#define CLIPFILTER_H

#include "ImageFilter.h"
#include "ClipThread.h"
#include "PathSelector.h"

class ClipFilter : public ImageFilter
{
    Q_OBJECT
public:
    ClipFilter();
    ~ClipFilter();
    const QPixmap& getResault() const;
    void setPixmap(const QPixmap& sourcePixmap);

private slots:
    void threadFinished();
    void cancelCliked();
    void pathClicked(QList<QPainterPath> path);

private:
    QPixmap myPixmap;
    QImage* myImage;
    ClipThread* myThread;
    PathSelector* mySelector;
};

#endif // CLIPFILTER_H
