#include "ClipThread.h"

void ClipThread::run()
{
    QImage clipedImage(workImage->width(),workImage->height(),
                                     workImage->format());
    QPainter* painter = new QPainter(&clipedImage);
    painter->fillRect(clipedImage.rect(),Qt::black);
    painter->setBrush(Qt::white);
    painter->setRenderHint(QPainter::Antialiasing);
    painter->setPen(Qt::transparent);
    for(int i = 0; i < myClipPath.count(); ++i)
        painter->drawPath(myClipPath.at(i));
    delete painter;
    workImage->setAlphaChannel(clipedImage);
}

ClipThread::ClipThread(QImage* sourceImage, QList<QPainterPath> clipPath)
{
    workImage = sourceImage;
    myClipPath = clipPath;
}
