#include "PathItem.h"

QRectF PathItem::boundingRect() const
{
    return QRectF (0.0f,0.0f,100.0f,100.0f);
}

void PathItem::paint(QPainter* painter,const QStyleOptionGraphicsItem* option,
           QWidget* widget)
{
    Q_UNUSED(option)
    Q_UNUSED(widget)

    painter->save();
    painter->setRenderHint(QPainter::Antialiasing);
    QPen pen;
    pen.setStyle(Qt::DashLine);
    pen.setWidth(2);
    pen.setColor(qApp->palette().alternateBase().color());
    painter->setPen(pen);
    painter->setBrush(QBrush(Qt::transparent));
    painter->drawRoundedRect(boundingRect(),15,15);
    pen.setColor(Qt::darkYellow);
    painter->setPen(pen);
    for(int i = 0; i < myPath.count(); ++i)
        painter->drawPath(myPath.at(i));
    painter->setPen(Qt::transparent);
    QColor color1 = touched ? QColor(44,41,99) : QColor(74,123,195);
    QColor color2 = QColor(37,69,116);
    QColor color3 = touched ? QColor(74,123,195) : QColor(44,41,99);
    QLinearGradient grad(0.0f,0.0f,100.0f,100.0f);
    grad.setColorAt(0.0f,color1);
    grad.setColorAt(0.5f,color2);
    grad.setColorAt(1.0f,color3);
    painter->setBrush(QBrush(grad));
    for(int i = 0; i < myPath.count(); ++i)
        painter->drawPath(myPath.at(i));
    painter->restore();
}

QPainterPath PathItem::shape() const
{
    QPainterPath shapePath;
    shapePath.setFillRule(Qt::WindingFill);
    for(int i = 0; i < myPath.count(); ++i)
        shapePath.addPath(myPath.at(i));
    return shapePath;
}

void PathItem::mousePressEvent(QGraphicsSceneMouseEvent* event)
{
    if(event->button() == Qt::LeftButton)
        emit clicked(myType);
}

void PathItem::hoverEnterEvent(QGraphicsSceneHoverEvent*)
{
    touched = true;
    update();
}

void PathItem::hoverLeaveEvent(QGraphicsSceneHoverEvent*)
{
    touched = false;
    update();
}

PathItem::PathItem(Paths::Type type, QList<QPainterPath> path)
    :QObject(0),QGraphicsItem(0)
{
    myType = type;
    myPath = path;
    setCursor(Qt::PointingHandCursor);
    touched = false;
    this->setAcceptHoverEvents(true);
}
