#ifndef PATHITEM_H
#define PATHITEM_H

#include <QObject>
#include <QGraphicsItem>
#include <QPainter>
#include <QGraphicsSceneMouseEvent>
#include <QApplication>
#include <QPalette>
#include <QLinearGradient>
#include "Paths.h"

class PathItem : public QObject, public QGraphicsItem
{
    Q_OBJECT
    Q_INTERFACES(QGraphicsItem)
public:
    PathItem(Paths::Type type, QList<QPainterPath> path);

    QRectF boundingRect() const;
    void paint(QPainter* painter,const QStyleOptionGraphicsItem* option,
               QWidget* widget);
    QPainterPath shape() const;

protected:
    void mousePressEvent(QGraphicsSceneMouseEvent* event);
    void hoverEnterEvent(QGraphicsSceneHoverEvent*);
    void hoverLeaveEvent(QGraphicsSceneHoverEvent*);

signals:
    void clicked(Paths::Type);

private:
    Paths::Type myType;
    QList<QPainterPath> myPath;
    bool touched;
};

#endif // PATHITEM_H
