#ifndef PATHSELECTOR_H
#define PATHSELECTOR_H

#include <QDialog>
#include <QPainterPath>
#include <QList>
#include <QGraphicsScene>
#include <QScrollBar>
#include <QKeyEvent>
#include "PathItem.h"

namespace Ui
{
    class PathSelector;
}

class PathSelector : public QDialog
{
    Q_OBJECT
public:
    PathSelector(QWidget *parent = 0);
    ~PathSelector();
    void setImageWidth(int width);
    void setImageHeight(int height);

protected:
    void showEvent(QShowEvent*);
    void keyPressEvent(QKeyEvent* event);

private slots:
    void cancelClicked();
    void pathClicked(Paths::Type type);

signals:
    void cancel();
    void pathSelected(QList<QPainterPath> path);

private:
    void makeScene();

    Ui::PathSelector *ui;
    int imageWidth;
    int imageHeight;
};

#endif // PATHSELECTOR_H
