#include "ColorInvertFilter.h"

const QPixmap& ColorInvertFilter::getResault() const
{
    return myPixmap;
}

void ColorInvertFilter::setPixmap(const QPixmap& sourcePixmap)
{
    myImage = new QImage(sourcePixmap.toImage());
    myThread = new ColorInvertThread(myImage);
    emit blockInput();
    connect(myThread,SIGNAL(finished()),this,SLOT(threadFinished()));
    myThread->start();
}

void ColorInvertFilter::threadFinished()
{
    myPixmap = QPixmap::fromImage(*myImage);
    delete myThread;
    myThread = NULL;
    emit finished();
}

ColorInvertFilter::ColorInvertFilter()
{
    myThread = NULL;
}

ColorInvertFilter::~ColorInvertFilter()
{
    if(myThread != NULL)
    {
        myThread->terminate();
        delete myThread;
    }
}
