#include "GrayScaleFilter.h"

const QPixmap& GrayScaleFilter::getResault() const
{
    return myPixmap;
}

void GrayScaleFilter::setPixmap(const QPixmap& sourcePixmap)
{
    myImage = new QImage(sourcePixmap.toImage());
    myThread = new GrayScaleThread(myImage);
    emit blockInput();
    connect(myThread,SIGNAL(finished()),this,SLOT(threadFinished()));
    myThread->start();
}

void GrayScaleFilter::threadFinished()
{
    myPixmap = QPixmap::fromImage(*myImage);
    delete myThread;
    myThread = NULL;
    emit finished();
}

GrayScaleFilter::GrayScaleFilter()
{
    myThread = NULL;
}

GrayScaleFilter::~GrayScaleFilter()
{
    if(myThread != NULL)
    {
        myThread->terminate();
        delete myThread;
    }
}
