#include "SepiaFilter.h"

const QPixmap& SepiaFilter::getResault() const
{
    return myPixmap;
}

void SepiaFilter::setPixmap(const QPixmap& sourcePixmap)
{
    myImage = new QImage(sourcePixmap.toImage()
                         .convertToFormat(QImage::Format_RGB32));
    myThread = new SepiaThread(myImage);
    emit blockInput();
    connect(myThread,SIGNAL(finished()),this,SLOT(threadFinished()));
    myThread->start();
}

void SepiaFilter::threadFinished()
{
    myPixmap = QPixmap::fromImage(*myImage);
    delete myThread;
    myThread = NULL;
    emit finished();
}

SepiaFilter::SepiaFilter()
{
    myThread = NULL;
}

SepiaFilter::~SepiaFilter()
{
    if(myThread != NULL)
    {
        myThread->terminate();
        delete myThread;
    }
}
