#ifndef colMan
#define colMan
#include <QSqlDatabase>
#include <QSqlQuery>
#include <QSqlError>
#include <QString>
#include <QStringList>
#include <QImage>
#include <QDate>
#include <QVariant>
#include <QBuffer>
#include <QImageWriter>
#include <QImageReader>
#include <QByteArray>
#include <QMessageBox>
#include <QCryptographicHash>
#include "ImageData.h"

class ColectionManipulator
{
public:
    ColectionManipulator();
    ~ColectionManipulator()
    {
        if(hasDatabase)
        {
            QSqlDatabase db = QSqlDatabase::database();
            db.close();
        }
    }
    QImage getPhotoMini(int id);
    QImage getPhoto(int id);
    QString getPhotoFormat(int id);
    QString getPhotoName(int id);
    QStringList getFolders();
    int getFolderContentCount(QString folderName);
    QStringList getPhotoInfo(int id);
    QStringList getMd5Sums();
    QStringList getAuthors();
    QStringList getTags();
    int getTagImageCount(QString tag);
    QString getPassWD();
    QString getCatalog(int index);
    QStringList getPhotoTags(int index);
    QList<int> getPhotosFromFolder(QString folderName);
    QList<int> searchForPhotos(QString name,QString author);
    QList<int> searchForPhotos(QString name,QString author,QDate from, QDate to);
    QList<int> searchForPhotosByTag(QString tag);
    bool hasImage(QString md5sum);
    int addImage(QImage image,ImageData& data,int quality);
    void openDataBase(QString filename, bool cheack = true);
    void newDataBase(QString filename,QString pass = " ");
    void moveImage(int index,QString catalogName);
    void dropImage(int index);
    void changeImage(int index,QImage photo,QImage mini, QString hash, QString format);
    void updateImageDescription(int index,QString description);
    void addTag(int index,QString tag);
    void removeTag(int index,QString tag);
    void renameImage(int index,QString name);
private:
    void checkBaseCount();
    void fixBase(int photoCount,int miniCount,int indexCount);
    bool hasDatabase;
};
#endif
