#include "welcominformation.h"

void WelcomInformation::setTopWidget(QWidget* widget)
{
    ui.sliderLayout->addWidget(widget);
}

void WelcomInformation::setHFolderCount(int count)
{
    ui.tableWidget->item(2,0)->setText(QString("%1").arg(count));
}

void WelcomInformation::setTotaCount(int count)
{
    ui.tableWidget->item(1,0)->setText(QString("%1").arg(count));
}

void WelcomInformation::setTotalFolderCount(int count)
{
    ui.tableWidget->item(0,0)->setText(QString("%1").arg(count));
}

void WelcomInformation::setData(QFileInfo fileInfo)
{
    //name
    ui.tableWidget->item(3,0)->setText(fileInfo.fileName()
                                       .remove(".gsalbP",Qt::CaseInsensitive));
    //owner
    ui.tableWidget->item(4,0)->setText(fileInfo.owner());
    //size
    ui.tableWidget->item(5,0)->setText(QString("%1 MB").
                                       arg(fileInfo.size()/(1024*1024)));
    //creation Date
    ui.tableWidget->item(6,0)->setText(fileInfo.created()
                                       .toString("dd.MMM.yyyy hh:mm:ss.zzz"));
    //modification Date
    ui.tableWidget->item(7,0)->setText(fileInfo.lastModified()
                                       .toString("dd.MMM.yyyy hh:mm:ss.zzz"));
    //read Date
    ui.tableWidget->item(8,0)->setText(fileInfo.lastRead()
                                       .toString("dd.MMM.yyyy hh:mm:ss.zzz"));

    //file path
    ui.tableWidget->item(9,0)->setText(fileInfo.absolutePath());

    //suffix
    ui.tableWidget->item(10,0)->setText(fileInfo.suffix());
}

void WelcomInformation::clearData()
{
    for(int i = 0; i < 11; ++i)
        ui.tableWidget->item(i,0)->setText(QString(tr("No Data")));
}


WelcomInformation::WelcomInformation(QWidget *parent)
        :QWidget(parent)
{
    ui.setupUi(this);
}

WelcomInformation::~WelcomInformation()
{
}
