#include "FolderInserterFolderItem.h"

QRectF FolderInserterFolderItem::boundingRect() const
{
    return QRectF(0.0f,0.0f,140.0f,180.0f);
}

int FolderInserterFolderItem::width() const
{
    return 140;
}

int FolderInserterFolderItem::height() const
{
    return 180;
}

void FolderInserterFolderItem::paint(QPainter* painter,const QStyleOptionGraphicsItem* option,
                                     QWidget* widget)
{
    Q_UNUSED(widget);

    painter->save();
    painter->setPen(Qt::DashLine);
    painter->setRenderHint(QPainter::Antialiasing);
    painter->setBrush(option->palette.brush(QPalette::AlternateBase));
    painter->drawRoundedRect(0,0,140,180,15.0f,15.0f);

    painter->setPen(Qt::black);

    if(!touched)
        painter->drawPixmap(6,6,QPixmap(":/eyecandy/folder.png"));
    else
        painter->drawPixmap(6,6,QPixmap(":/eyecandy/folderA.png"));

    painter->setFont(QFont("Courier",8,8));
    QString drawnText;
    if(myFolderName.length() > 50)
    {
        drawnText = myFolderName.left(47) + "...";
    }
    else
        drawnText = myFolderName;

    painter->drawText(QRectF(7.0f,135.0f,126.0f,42.0f),
                      Qt::AlignHCenter|Qt::AlignVCenter|Qt::TextWrapAnywhere,
                      drawnText,
                      new QRectF(0.0f,0.0f,120.0f,42.0f));
    painter->restore();
}

void FolderInserterFolderItem::dragEnterEvent(QGraphicsSceneDragDropEvent *event)
{
    if(event->mimeData()->hasText())
    {
        event->setAccepted(true);
        touched = true;
        update();
    }
    else
    {
        event->setAccepted(false);
    }
}

void FolderInserterFolderItem::dragLeaveEvent(QGraphicsSceneDragDropEvent *event)
{
    Q_UNUSED(event);
    touched = false;
    update();
}

void FolderInserterFolderItem::dropEvent(QGraphicsSceneDragDropEvent *event)
{
    touched = false;
    QString imageName;
    imageName = event->mimeData()->text();
    emit movePhoto(imageName,myFolderName);
    event->acceptProposedAction();
    update();
}

FolderInserterFolderItem::FolderInserterFolderItem(QString name)
        :QGraphicsObject()
{
    setAcceptDrops(true);
    touched = false;
    myFolderName = name;
}
