#ifndef FOLDERINSERTERFOLDERITEM_H
#define FOLDERINSERTERFOLDERITEM_H

#include <QGraphicsObject>
#include <QGraphicsSceneDragDropEvent>
#include <QMimeData>
#include <QPainter>
#include <QPixmap>
#include <QStyleOptionGraphicsItem>

class FolderInserterFolderItem : public QGraphicsObject
{
    Q_OBJECT
public:
    FolderInserterFolderItem(QString name);

    QRectF boundingRect() const;
    void paint(QPainter* painter,const QStyleOptionGraphicsItem* option,
               QWidget* widget);

    int width() const;
    int height() const;

protected:
    void dragEnterEvent(QGraphicsSceneDragDropEvent *event);
    void dragLeaveEvent(QGraphicsSceneDragDropEvent *event);
    void dropEvent(QGraphicsSceneDragDropEvent *event);

signals:
    void movePhoto(QString photo,QString FolderName);

private:
    QString myFolderName;
    bool touched;
};

#endif // FOLDERINSERTERFOLDERITEM_H
