#ifndef FOLDERINSERTERPHOTOITEM_H
#define FOLDERINSERTERPHOTOITEM_H

#include <QGraphicsItem>
#include <QGraphicsSceneMouseEvent>
#include <QStyleOptionGraphicsItem>
#include <QApplication>
#include <QPixmap>
#include <QDrag>
#include <QMimeData>
#include <QPainter>

class FolderInserterPhotoItem : public QGraphicsItem
{
public:
    FolderInserterPhotoItem(QPixmap* noMiniPixmap,QString name);
    void setMini(QPixmap mini);

    QRectF boundingRect() const;
    void paint(QPainter *painter, const QStyleOptionGraphicsItem *option,
               QWidget *widget);

    int width() const;
    int height() const;

protected:
    void mousePressEvent(QGraphicsSceneMouseEvent* event);
    void mouseMoveEvent(QGraphicsSceneMouseEvent* event);
    void mouseReleaseEvent(QGraphicsSceneMouseEvent* event);

private:
    bool hasMini;
    QPixmap* defaultNoMiniPixmap;
    QString myName;
    QPixmap myMini;
};

#endif // FOLDERINSERTERPHOTOITEM_H
