#ifndef GS_inserter
#define GS_inserter

#include <QWidget>
#include <QCloseEvent>
#include <QFileDialog>
#include <QStringList>
#include <QMessageBox>
#include <QInputDialog>
#include <QDate>
#include "ui_GS_albumer_inserter.h"

using namespace Ui;

class GS_albumer_inserter: public QWidget
{
    Q_OBJECT
public:
    GS_albumer_inserter(QWidget* parent=0);
    ~GS_albumer_inserter()
    {}
    void setNeedToClose();
    QString getFile();
    QString getName();
    QString getCatalog();
    QDate getDate();
    QString getAuthor();
    QString getDisc();
    QString getFormat();

public slots:
    void openFile();
    void clearData();
    void clearCatalogs();
    void insertClicked();
    void createCatalog();
    void populateCatalogs(QStringList list);
    void descTextChanged();

signals:
    void readyForInserting();

protected:
    void closeEvent(QCloseEvent* event);

private:
    Ui_InsertDialogUi ui;
    bool needToClose;
    QString filename;
    QString format;
    
};
#endif
