#ifndef FOLDERINSERTERDRAGPHOTOLIST_H
#define FOLDERINSERTERDRAGPHOTOLIST_H

#include <QtGui/QWidget>
#include <QGraphicsScene>
#include <QPixmap>
#include <QMap>
#include <QTimer>
#include <QScrollBar>
#include "ui_folderinserterdragphotolist.h"
#include "FolderInserterPhotoItem.h"

class FolderInserterDragPhotoList : public QWidget
{
    Q_OBJECT
public:
    FolderInserterDragPhotoList(QWidget *parent = 0);
    ~FolderInserterDragPhotoList();

    void addImageItem(QString name);
    void setItemMiniature(QString name,QPixmap mini);
    void removeItem(QString name);
    void addItems(QStringList itemList);
    void updateMiniatures();
    void clear();

protected:
    void resizeEvent(QResizeEvent* event);
    void hideEvent(QHideEvent* event);
    void showEvent(QShowEvent* event);

private slots:
    void requestMiniature();

signals:
    void requestMiniature(QString name);

private:
    void makeScene();
    int scrollValue;
    Ui::FolderInserterDragPhotoList_ui ui;
    QPixmap* defaultNoMini;
    QList<FolderInserterPhotoItem*> noMiniatureItems;
    QMap<QString,FolderInserterPhotoItem*> itemMap;
    QTimer* singleShotRequestTimer;
};

#endif // FOLDERINSERTERDRAGPHOTOLIST_H
