#ifndef FOLDERINSERTERFOLDERVIEW_H
#define FOLDERINSERTERFOLDERVIEW_H

#include <QtGui/QWidget>
#include <QGraphicsScene>
#include <QMap>
#include <QScrollBar>
#include <QMouseEvent>
#include <QTimer>
#include "ui_folderinserterfolderview.h"
#include "FolderInserterFolderItem.h"
#include "folderScene.h"

class FolderInserterFolderView : public QWidget
{
    Q_OBJECT
public:
    FolderInserterFolderView(QWidget *parent = 0);
    ~FolderInserterFolderView();

    void addItem(QString name);
    void addItems(QStringList itemList);

    void clear();

protected:
    void resizeEvent(QResizeEvent* event);
    void hideEvent(QHideEvent* event);
    void showEvent(QShowEvent* event);

private slots:
    void dropAction(QString imageName,QString folderName);
    void dragMove(int y);
    void dragEnd();
    void scrollUp();
    void scrollDown();

signals:
    void movePhoto(QString photo,QString FolderName);

private:
    void makeScene();
    int scrollValue;
    QTimer* scrollUpTimer;
    QTimer* scrollDownTimer;
    QMap<QString,FolderInserterFolderItem*> itemMap;
    Ui::FolderInserterFolderView_ui ui;
};

#endif // FOLDERINSERTERFOLDERVIEW_H
