#ifndef GS_ALBUMER_FOLDER_INSERTER_H
#define GS_ALBUMER_FOLDER_INSERTER_H

#include <QWidget>
#include <QFile>
#include <QFileInfo>
#include <QDir>
#include <QList>
#include <QMap>
#include <QCloseEvent>
#include <QMessageBox>
#include <QInputDialog>
#include <QCoreApplication>
#include "Colection/ImageData.h"
#include "folderinserterdragphotolist.h"
#include "folderinserterfolderview.h"
#include "ui_gs_albumer_folder_inserter.h"
#include "Misc/GS_albumer_progress.h"

class GS_albumer_folder_inserter :public QWidget
{
    Q_OBJECT
    Q_DISABLE_COPY(GS_albumer_folder_inserter)
        public:
            explicit GS_albumer_folder_inserter(QWidget *parent = 0);
    ~GS_albumer_folder_inserter()
    {
        delete myProgress;
    }
    void setInList(QMap<QString,QFileInfo> inList_,QStringList catList);
    void setNeedToClose();
    QList<ImageData> getOutList();

signals:
    void insertReady();
    void photoProcesed(int);

protected:
    void closeEvent(QCloseEvent* event);
    void hideEvent(QHideEvent* event);

protected slots:
    void newCatalogClicked();
    void inListItemChanged();
    void outListItemChanged();
    void addAllClicked();
    void addClicked();
    void updateClicked();
    void removeClicked();
    void discardClicked();
    void commitClicked();
    void descTextChanged();
    void updateMiniature(QString name);
    void movePhotoTrigered(QString photoName,QString FolderName);
    void cancelClicked();
    void sizeLimitClicked(bool state);

private:
    Ui::Form ui;
    QMap<QString,ImageData> inList;
    QMap<QString,ImageData> outList;
    QMap<QString,QFileInfo> fileInfoList;
    QString currFileFormat;
    FolderInserterDragPhotoList* photoListWidget;
    FolderInserterFolderView* folderListWidget;
    GS_albumer_progress* myProgress;
    bool needToClose;
    bool cancel;
};

#endif // GS_ALBUMER_FOLDER_INSERTER_H
