#include "GS_albumer_progress.h"

void GS_albumer_progress::setMaxCount(int i)
{
    progresser->setMaxCount(i);
    this->repaint(this->rect());
    ui.graphicsView->repaint(ui.graphicsView->rect());
    qApp->processEvents();
}

void GS_albumer_progress::setCount(int i)
{
    progresser->setCount(i);
    this->repaint(this->rect());
    ui.graphicsView->repaint(ui.graphicsView->rect());
    qApp->processEvents();
}

void GS_albumer_progress::setNeedToClose()
{
    needToClose = true;
}

void GS_albumer_progress::setCancel(bool shown)
{
    if(!shown)
        ui.cancelButton->hide();
    else
        ui.cancelButton->show();
}

void GS_albumer_progress::closeEvent(QCloseEvent* event)
{
    if(needToClose)
    {
        event->accept();
    }
    else
    {
        event->ignore();
    }
}

void GS_albumer_progress::cancel()
{
    emit cancelClicked();
}

void GS_albumer_progress::makeScene()
{
    QGraphicsScene* scene = new QGraphicsScene(0,0,150,150);
    scene->setBackgroundBrush(qApp->palette().base());
    ui.graphicsView->setScene(scene);

    progresser = new ProgressItem;
    progresser->setPos(0,0);
    scene->addItem(progresser);
}

GS_albumer_progress::GS_albumer_progress(QWidget* parent)
    :QDialog(parent)
{
    ui.setupUi(this);
    needToClose = false;
    this->setModal(true);
    this->setWindowFlags(Qt::FramelessWindowHint|Qt::Dialog);
    makeScene();
    connect(ui.cancelButton,SIGNAL(clicked()),this,SLOT(cancel()));
}
