#include "ProgressItem.h"

QRectF ProgressItem::boundingRect() const
{
    return QRectF(0.0f,0.0f,150.0f,150.0f);
}
void ProgressItem::paint(QPainter* painter,const QStyleOptionGraphicsItem* optiont,
           QWidget* widget)
{
    Q_UNUSED(optiont)
    Q_UNUSED(widget)
    int startAngle = 0;
    int span = 16 * static_cast<int>(static_cast<float>(count) * countDegre);
    int startInvert = startAngle + span;
    int spanInvert = 5760 - span;
    painter->setRenderHint(QPainter::Antialiasing);
    painter->setPen(Qt::transparent);
    painter->setBrush(myBrush);
    painter->drawPie(0,0,150,150,startAngle,span);
    painter->setBrush(myBrushInvert);
    painter->drawPie(0,0,150,150,startInvert,spanInvert);
}

void ProgressItem::setCount(int value)
{
    if(value > maxCount)
        count = maxCount;
    else
    {
        if(value <= 0)
            count = 0;
        else
            count = value;
    }
    update();
}

void ProgressItem::setMaxCount(int value)
{
    if(value <= 0)
    {
        maxCount = 1;
        count = 0;
        countDegre = 360;
    }
    else
    {
        maxCount = value;
        count = 0;
        countDegre = 360.0f/static_cast<float>(maxCount);
    }
    update();
}

ProgressItem::ProgressItem(QGraphicsItem* parent)
    :QGraphicsItem(parent)
{
    maxCount = 1;
    count = 1;
    countDegre = 360.0f;
    myBrush = QBrush(QPixmap(":/eyecandy/progress.png"));
    myBrushInvert = QBrush(QPixmap(":/eyecandy/progressInv.png"));
}
