#include "gs_albumer_slider_item.h"
QRectF GS_albumer_slider_item::boundingRect() const
{
    qreal penWidth = 1;
    qreal itemWidth = scene()->width();
    return QRectF(0- penWidth / 2, 0 - penWidth / 2,
                  itemWidth + penWidth / 2, 80 + penWidth / 2);
}

void GS_albumer_slider_item::paint(QPainter *painter,
                                   const QStyleOptionGraphicsItem*,QWidget*)
{
    qreal SceneWidth = scene()->width();
    painter->setPen(Qt::NoPen);
    painter->setBrush(QBrush(QPixmap(":eyecandy/folderBrush.png")));
    painter->drawRect(0,0,width_,80);
    painter->setBrush(QBrush(QPixmap(":eyecandy/allBrush.png")));
    int newWidth = static_cast<int>(SceneWidth) - width_;
    painter->drawRect(width_,0,newWidth,80);
    painter->setPen(Qt::SolidLine);
    painter->setFont(QFont("Courier"));
    painter->drawPixmap(width_-4,0,QPixmap(":eyecandy/joiner.png"));
}

void GS_albumer_slider_item::setValues(int part,int ent)
{
    whantPercent = static_cast<float>((part*100))/static_cast<float>(ent);
    animator->start();
}

void GS_albumer_slider_item::animate()
{
    percent = static_cast<int>((whantPercent * scene()->width())/100);
    if(width_ == percent)
    {
        animator->stop();
        update();
    }
    else
    {
        if(width_ > percent)
        {
            if(width_ - 20 < percent) width_ -= width_ - percent;
            else width_ -= 20;
        }
        if(width_ < percent)
        {
            if(width_ + 20 > percent) width_ += percent - width_;
            else width_ += 20;
        }
    }
    this->update();
}

void GS_albumer_slider_item::updateSlide()
{
    animator->start();
}

GS_albumer_slider_item::GS_albumer_slider_item()
    :QGraphicsObject()
{
    animator =  new QTimer(this);
    animator->setInterval(25);
    width_ = 0;
    percent = 0;
    whantPercent = 0;
    connect(animator,SIGNAL(timeout()),this,SLOT(animate()));
}
