#include "gs_albumer_work_animation.h"

void GS_albumer_work_animation::startAnimation()
{
    shooter->start();
}

void GS_albumer_work_animation::stopAnimation()
{
    shooter->stop();
}

void GS_albumer_work_animation::resizeEvent(QResizeEvent*)
{
    QLinearGradient gradient(0, (90 - height()) * 2, 0, this->height());
    gradient.setColorAt(0.0,QColor(235, 235, 235, 255));
    gradient.setColorAt(0.1,QColor(227, 227, 227, 255));
    gradient.setColorAt(0.5,QColor(237, 237, 237, 255));
    gradient.setColorAt(0.51,QColor(197, 197, 197, 255));
    gradient.setColorAt(1.0,QColor(235, 235, 235, 255));
    ui.animationView->scene()->setBackgroundBrush(gradient);
}

void GS_albumer_work_animation::animateItems()
{
    left->translate(25,25);
    left->rotate(-5);
    left->translate(-25,-25);
    right->translate(25,25);
    right->rotate(5);
    right->translate(-25,-25);
    centerRight->translate(15,15);
    centerRight->rotate(-10);
    centerRight->translate(-15,-15);
    centerLeft->translate(15,15);
    centerLeft->rotate(10);
    centerLeft->translate(-15,-15);
}

GS_albumer_work_animation::GS_albumer_work_animation(QWidget *parent)
    :QWidget(parent)
{
    ui.setupUi(this);
    right = new QGraphicsPixmapItem(
            QPixmap(":/eyecandy/rightWheel.png"));
    right->setTransformationMode(Qt::SmoothTransformation);
    centerRight = new QGraphicsPixmapItem(
            QPixmap(":/eyecandy/centerRightWheel.png"));
    centerRight->setTransformationMode(Qt::SmoothTransformation);
    left = new QGraphicsPixmapItem(
            QPixmap(":/eyecandy/leftWheel.png"));
    left->setTransformationMode(Qt::SmoothTransformation);
    centerLeft = new QGraphicsPixmapItem(
            QPixmap(":/eyecandy/centerLeftWheel.png"));
    centerLeft->setTransformationMode(Qt::SmoothTransformation);
    QGraphicsScene* scene =  new QGraphicsScene(0,0,82,90);

    ui.animationView->setScene(scene);
    left->setPos(1,2);
    scene->addItem(left);
    scene->addItem(centerLeft);
    centerLeft->setPos(0,55);
    scene->addItem(right);
    right->setPos(32,35);
    scene->addItem(centerRight);
    centerRight->setPos(52,5);
    shooter = new QTimer();
    shooter->setInterval(50);
    connect(shooter,SIGNAL(timeout()),this,SLOT(animateItems()));
}
