#ifndef PLUGINMANAGER_H
#define PLUGINMANAGER_H

#include <QPluginLoader>
#include <QMap>
#include <QDir>
#include <QApplication>
#include "ImageFilterInterface.h"

class PluginManager
{
public:
    static PluginManager* getInstance();
    ImageFilter* getImageFilterByName(QString name);
    QStringList getImageFilterNames() const;

private:
    PluginManager();
    void loadPlugins();
    static PluginManager* myInstance;

    QMap<QString, ImageFilterInterface*> imageFilterRoots;
};

#endif // PLUGINMANAGER_H
