#include "ScroolOperationWidget.h"

void ScroolOperationWidget::paintEvent(QPaintEvent*)
{
    QPainter painter(this);
    painter.setPen(Qt::transparent);
    int dy = isTouched ? myDy : 0;
    painter.drawPixmap((this->width() - myPixmap.width())/2,3 + dy,myPixmap);
}

void ScroolOperationWidget::setPixmap(const QPixmap& pixmap)
{
    myPixmap = pixmap;
    this->setMinimumHeight(myPixmap.height() + 6);
    this->setMaximumHeight(myPixmap.height() + 6);
    update();
}

void ScroolOperationWidget::enterEvent(QEvent*)
{
    myTimer->start(50);
    isTouched = true;
    update();
}

void ScroolOperationWidget::leaveEvent(QEvent*)
{
    myTimer->stop();
    isTouched = false;
    update();
}

void ScroolOperationWidget::touchAction()
{
    emit touched();
}

ScroolOperationWidget::ScroolOperationWidget(const QPixmap& pixmap, int dy,QWidget* parent)
    :QWidget(parent),myPixmap(pixmap),myDy(dy)
{
    myTimer = new QTimer(this);
    connect(myTimer,SIGNAL(timeout()),this,SLOT(touchAction()));
    isTouched = false;
    this->setMinimumHeight(myPixmap.height() + 6);
    this->setMaximumHeight(myPixmap.height() + 6);
}
