#ifndef SCROOLOPERATIONWIDGET_H
#define SCROOLOPERATIONWIDGET_H

#include <QWidget>
#include <QPainter>
#include <QTimer>
#include <QPixmap>

class ScroolOperationWidget : public QWidget
{
    Q_OBJECT
public:
    ScroolOperationWidget(const QPixmap& pixmap, int dy, QWidget* parent = 0);
    void setPixmap(const QPixmap& pixmap);

protected:
    void paintEvent(QPaintEvent*);
    void enterEvent(QEvent*);
    void leaveEvent(QEvent*);

signals:
    void touched();

private slots:
    void touchAction();

private:
    QTimer* myTimer;
    QPixmap myPixmap;
    bool isTouched;
    int myDy;
};

#endif // SCROOLOPERATIONWIDGET_H
