#ifndef CATEGORYITEM_H
#define CATEGORYITEM_H

#include <QGraphicsObject>
#include <QGraphicsScene>
#include <QPixmap>
#include <QPainter>
#include <QGraphicsSceneHoverEvent>
#include <QGraphicsSceneMouseEvent>
#include <QGraphicsSceneDragDropEvent>
#include <QMimeData>

class CategoryItem : public QGraphicsObject
{
    Q_OBJECT

public:
    CategoryItem(QPixmap myItemPixmap,QPixmap myItemPixmap_alt,QString text,
                 unsigned int index);
    QRectF boundingRect() const;
    void paint(QPainter *painter, const QStyleOptionGraphicsItem *option,
               QWidget *widget);
    void setIndex(unsigned int index);

protected:
    void hoverEnterEvent(QGraphicsSceneHoverEvent* event);
    void hoverLeaveEvent(QGraphicsSceneHoverEvent* event);
    void mousePressEvent(QGraphicsSceneMouseEvent* event);
    void dragEnterEvent(QGraphicsSceneDragDropEvent* event);
    void dropEvent(QGraphicsSceneDragDropEvent* event);
    void dragLeaveEvent(QGraphicsSceneDragDropEvent* event);

signals:
    void clicked(unsigned int index);
    void touched(unsigned int index);
    void photoDroped(int photoId, int itemIndex);

private:
    QPixmap myPixmap,myPixmap_alt;
    QString myText;
    unsigned int myIndex;
    bool isTouched;
};

#endif // CATEGORYITEM_H
