#include "GS_file_filter.h"

void GS_file_filter::setFilterLists(QList<QFileInfo> fileList_)
{
    fileList.clear();
    workList.clear();
    fileList = fileList_;
}

void GS_file_filter::run()
{
    stop_ = false;
    filter();
}

void GS_file_filter::stop()
{
    stop_ = true;
}

void GS_file_filter::filter()
{
    foreach(const QFileInfo item, fileList)
    {
        if(item.exists())
        {
            QString currFileFormat = "PNG";
            if(item.fileName().endsWith(".PNG",Qt::CaseInsensitive))
            {
                currFileFormat = "PNG";
            }
            if(item.fileName().endsWith(".JPG",Qt::CaseInsensitive))
            {
                currFileFormat = "JPG";
            }
            if(item.fileName().endsWith(".JPEG",Qt::CaseInsensitive))
            {
                currFileFormat = "JPEG";
            }
            if(item.fileName().endsWith(".TIFF",Qt::CaseInsensitive))
            {
                currFileFormat = "TIFF";
            }
            QBuffer buffer;
            QImageWriter writer(&buffer,currFileFormat.toAscii());
            writer.write(QImage(item.absoluteFilePath()));
            QString temp(QCryptographicHash::hash(buffer.data(),QCryptographicHash::Md4));
            mutex->lock();
            if(!masterThread->hashList.contains(temp))
            {
                masterThread->hashList<<temp;
                workList[temp]=item;
            }
            mutex->unlock();
            msleep(25); //sleeping to let the cpu catchup with gui event processing
        }
        if(stop_)
        {
            return;
        }
    }
    emit filterFinished();
}

QMap<QString,QFileInfo> GS_file_filter::getFileList()
{
    return workList;
}

GS_file_filter::GS_file_filter(QMutex* mutex_,GS_hash_holder* masterThread_)
    :QThread()
{
    mutex = mutex_;
    masterThread = masterThread_;
}
