#ifndef GS_FILE_FILTER_H
#define GS_FILE_FILTER_H

#include <QThread>
#include <QList>
#include <QMap>
#include <QCryptographicHash>
#include <QFileInfo>
#include <QStringList>
#include <QBuffer>
#include <QImageWriter>
#include <QImage>
#include <QMutex>
#include "gs_hash_holder.h"


class GS_file_filter : public QThread
{
    Q_OBJECT
public:
    GS_file_filter(QMutex* mutex_,GS_hash_holder* masterThread_);
    ~GS_file_filter()
    {}
    void setFilterLists(QList<QFileInfo> fileList_);
    QMap<QString,QFileInfo> getFileList();
    void stop();

signals:
    void filterFinished();

protected:
    void run();
    void filter();

private:
    QList<QFileInfo> fileList;
    QMap<QString,QFileInfo> workList;
    bool stop_;
    QMutex* mutex;
    GS_hash_holder* masterThread;
};

#endif // GS_FILE_FILTER_H
