#include "GS_file_search.h"

void GS_file_search::setDir(QString dirPath)
{
    FileList.clear();
    searchDir = QDir(dirPath);
}

void GS_file_search::findeFiles(QDir sDir,bool first)
{
    QStringList dirFilter;
    dirFilter<<"*";
    foreach(const QFileInfo file, sDir.entryInfoList(dirFilter,QDir::AllDirs))
    {
        if(file.absolutePath()==sDir.absolutePath())
        {
            QDir dir(file.absoluteFilePath());
            if(dir.dirName() != "." && dir.dirName() != "..")
                findeFiles(dir,false);
        }
    }
    FileList<<sDir.entryInfoList(fileFilters_);
    if(stop_)
        return;
    if(first)
        emit finished();
}

void GS_file_search::run()
{
    stop_ = false;
    findeFiles(searchDir,true);
}

void GS_file_search::stop()
{
    stop_ = true;
}

void GS_file_search::setFileFilters(QStringList filters)
{
    fileFilters_ = filters;
}

QList<QFileInfo> GS_file_search::getFileList()
{
    return FileList;
}

GS_file_search::GS_file_search(QStringList fileFilters)
    :QThread()
{
    fileFilters_ = fileFilters;
}
