#include "TagEditor.h"
#include "ui_TagEditor.h"

void TagEditor::okClicked()
{
    if(ui->tagBox->currentText().trimmed() != "")
    {
        emit tagPicked(ui->tagBox->currentText().trimmed());
        close();
    }
}

void TagEditor::newClicked()
{
    QString newTag = "";
    newTag = QInputDialog::getText(this,tr("New tag creator"),tr("New tag:"));
    newTag = newTag.toUpper();
    newTag.remove("|");
    if(newTag.trimmed() != "")
    {
        int index = ui->tagBox->findText(newTag.trimmed());
        if(index == -1)
        {
            ui->tagBox->addItem(newTag.trimmed());
            ui->tagBox->setCurrentIndex(ui->tagBox->findText(newTag.trimmed()));
        }
        else
        {
            ui->tagBox->setCurrentIndex(index);
        }
    }
}

void TagEditor::setTagList(QStringList tags)
{
    ui->tagBox->clear();
    ui->tagBox->addItems(tags);
    ui->tagBox->setCurrentIndex(-1);
}

TagEditor::TagEditor(QWidget *parent)
    :QDialog(parent),ui(new Ui::TagEditor_ui)
{
    ui->setupUi(this);
    this->setWindowModality(Qt::ApplicationModal);
    this->setAttribute(Qt::WA_DeleteOnClose,true);
    connect(ui->cancelButton,SIGNAL(clicked()),this,SLOT(close()));
    connect(ui->okButton,SIGNAL(clicked()),this,SLOT(okClicked()));
    connect(ui->newButton,SIGNAL(clicked()),this,SLOT(newClicked()));
}

TagEditor::~TagEditor()
{
    delete ui;
}
