#include "TagRemover.h"
#include "ui_TagRemover.h"

void TagRemover::setData(int id,QStringList tags)
{
    ui->tagBox->clear();
    ui->tagBox->addItems(tags);
    ui->tagBox->setCurrentIndex(-1);
    myId = id;
}

void TagRemover::removeClicked()
{
    if(ui->tagBox->currentText() != "")
    {
        emit removeImageTag(myId, ui->tagBox->currentText());
        close();
    }
}

TagRemover::TagRemover(QWidget *parent)
    :QDialog(parent),ui(new Ui::TagRemover_ui)
{
    ui->setupUi(this);
    this->setWindowModality(Qt::ApplicationModal);
    this->setAttribute(Qt::WA_DeleteOnClose,true);
    connect(ui->cancleButton,SIGNAL(clicked()),this,SLOT(close()));
    connect(ui->removeButton,SIGNAL(clicked()),this,SLOT(removeClicked()));
}

TagRemover::~TagRemover()
{
    delete ui;
}
