#include "gs_albumer_album_creator.h"

void GS_albumer_album_creator::closeEvent(QCloseEvent*)
{
    hide();
}

void GS_albumer_album_creator::keyPressEvent(QKeyEvent* event)
{
    event->ignore();
}

QString GS_albumer_album_creator::getPassword()
{
    return passwd;
}

QString GS_albumer_album_creator::getFileName()
{
    return filename;
}

void GS_albumer_album_creator::clear()
{
    ui.passLine1->setText("");
    ui.passLine2->setText("");
    ui.pathLine->setText("");
    ui.passCheck->setChecked(false);
    ui.passLine1->setEnabled(false);
    ui.passLine2->setEnabled(false);
}

void GS_albumer_album_creator::okClicked()
{
    if(validatePassword())
    {
        if(ui.pathLine->text().trimmed() != "")
        {
            emit newAlbumReady();
            hide();
        }
        else
        {
            QMessageBox::warning(this,tr("File Error"),tr("No file specified."));
        }
    }
    else
    {
        return;
    }
}

void GS_albumer_album_creator::calcelClicked()
{
    hide();
}

bool GS_albumer_album_creator::validatePassword()
{
    if(ui.passCheck->isChecked())
    {
        if(ui.passLine1->text().trimmed() != ui.passLine2->text().trimmed())
        {
            QMessageBox::warning(this,tr("Invalid password"),tr("Passwords don't match"));
            return false;
        }
        else
        {
            if(ui.passLine1->text().trimmed() == "")
            {
                QMessageBox::warning(this,tr("Pasword invalid"),tr("Null password"));
                return false;
            }
            else
            {
                passwd = ui.passLine1->text();
                return true;
            }
        }
    }
    else
    {
        passwd = " ";
        return true;
    }
}

void GS_albumer_album_creator::enablePass(int state)
{
    if(state == 2)
    {
        ui.passLine1->setEnabled(true);
        ui.passLine2->setEnabled(true);
    }
    else
    {
        ui.passLine1->setEnabled(false);
        ui.passLine2->setEnabled(false);
    }
}

void GS_albumer_album_creator::getPahtClicked()
{
    QString fname = "";
    fname = QFileDialog::getSaveFileName(this, tr("Save File"),QDir::homePath(),
                                         tr("Album File(*.gsAlb)"));
    if(fname == "")
        return;
    else
    {
        if(!fname.endsWith(".gsAlb",Qt::CaseInsensitive))
            fname +=".gsAlb";
        ui.pathLine->setText(fname);
        filename = fname;
    }
}

GS_albumer_album_creator::GS_albumer_album_creator(QWidget *parent)
    :QDialog(parent)
{
    ui.setupUi(this);
    this->setModal(true);
    connect(ui.passCheck,SIGNAL(stateChanged(int)),this,SLOT(enablePass(int)));
    connect(ui.okButton,SIGNAL(clicked()),this,SLOT(okClicked()));
    connect(ui.cancelButton,SIGNAL(clicked()),this,SLOT(calcelClicked()));
    connect(ui.fileButton,SIGNAL(clicked()),this,SLOT(getPahtClicked()));
    connect(ui.passLine1,SIGNAL(returnPressed()),this,SLOT(okClicked()));
    connect(ui.passLine2,SIGNAL(returnPressed()),this,SLOT(okClicked()));
}
