#include "gs_albumer_configurator.h"

void GS_albumer_configurator::closeEvent(QCloseEvent* event)
{
    if(needToClose)
    {
        event->accept();
    }
    else
    {
        event->ignore();
        hide();
    }
}

void GS_albumer_configurator::showEvent (QShowEvent* event)
{
    //BG Style
    if(GS_config_holder::getBackGroundType() == ":/eyecandy")
        ui.t0Button->setChecked(true);
    if(GS_config_holder::getBackGroundType() == ":/eyecandy/bgTheme1")
        ui.t1Button->setChecked(true);
    if(GS_config_holder::getBackGroundType() == ":/eyecandy/bgTheme2")
        ui.t2Button->setChecked(true);
    if(GS_config_holder::getBackGroundType() == ":/eyecandy/bgTheme3")
        ui.t3Button->setChecked(true);
    if(GS_config_holder::getBackGroundType() == ":/eyecandy/bgTheme4")
        ui.t4Button->setChecked(true);
    if(GS_config_holder::getBackGroundType() == ":/eyecandy/bgTheme5")
        ui.t5Button->setChecked(true);
    if(GS_config_holder::getBackGroundType() == ":/eyecandy/bgTheme6")
        ui.t6Button->setChecked(true);
    if(GS_config_holder::getBackGroundType() == ":/eyecandy/bgTheme7")
        ui.t7Button->setChecked(true);
    if(!GS_config_holder::getBackGroundType().startsWith(":"))
    {
        ui.bgCustomBox->setChecked(true);
        ui.bgFolderLine->setText(GS_config_holder::getBackGroundType());
        customBg(true);
    }
    if(GS_config_holder::getBackGroundType().startsWith(":"))
    {
        ui.bgCustomBox->setChecked(false);
        customBg(false);
    }
    //Deco Style
    if(GS_config_holder::getDecoLineType() == ":/eyecandy")
        ui.dt0Button->setChecked(true);
    if(GS_config_holder::getDecoLineType() == ":/eyecandy/decoTheme1")
        ui.dt1Button->setChecked(true);
    if(GS_config_holder::getDecoLineType() == ":/eyecandy/decoTheme2")
        ui.dt2Button->setChecked(true);
    if(GS_config_holder::getDecoLineType() == ":/eyecandy/decoTheme3")
        ui.dt3Button->setChecked(true);
    if(GS_config_holder::getDecoLineType() == ":/eyecandy/decoTheme4")
        ui.dt4Button->setChecked(true);
    if(GS_config_holder::getDecoLineType() == ":/eyecandy/decoTheme5")
        ui.dt5Button->setChecked(true);
    if(GS_config_holder::getDecoLineType() == ":/eyecandy/decoTheme6")
        ui.dt6Button->setChecked(true);
    if(GS_config_holder::getDecoLineType() == ":/eyecandy/decoTheme7")
        ui.dt7Button->setChecked(true);
    if(!GS_config_holder::getDecoLineType().startsWith(":"))
    {
        ui.dtCustomBox->setChecked(true);
        ui.dtFolderLine->setText(GS_config_holder::getDecoLineType());
        customDt(true);
    }
    if(GS_config_holder::getDecoLineType().startsWith(":"))
    {
        ui.dtCustomBox->setChecked(false);
        customDt(false);
    }
    ui.applyButton->setEnabled(false);
    //Albumer Options
    //ShowMenu
    ui.menuBox->setChecked(GS_config_holder::getShowMenu());
    //menuBar
    ui.mainColFile->setChecked(GS_config_holder::getCollFile());
    ui.mainColSearch->setChecked(GS_config_holder::getCollSearch());
    ui.mainColConfig->setChecked(GS_config_holder::getCollConfig());
    ui.mainMaxi->setChecked(GS_config_holder::getStartMaxi());
    //cat View
    ui.colCatOpt->setChecked(GS_config_holder::getCatCollOptions());
    ui.colCatMark->setChecked(GS_config_holder::getCatCollMarkers());
    ui.colCatShows->setChecked(GS_config_holder::getCatCollShows());
    ui.catShowInfo->setChecked(GS_config_holder::getCatShowInfo());
    //Viewer
    ui.colViewEdit->setChecked(GS_config_holder::getViewCollEdit());
    ui.colViewFile->setChecked(GS_config_holder::getViewCollFile());
    ui.viewFit->setChecked(GS_config_holder::getViewFit());
    ui.viewMaxi->setChecked(GS_config_holder::getViewMaxi());
    //Quality
    ui.qualiSlider->setValue(GS_config_holder::getQuality());
    ui.qualiLabel->setText(QString("%1").arg(GS_config_holder::getQuality()));
    //Base
    ui.checkIntegratyBox->setChecked(GS_config_holder::getCheckBase());
    event->accept();
}

void GS_albumer_configurator::applyClicked()
{
    //BG Style
    if(!ui.bgCustomBox->isChecked())
    {
        if(ui.t0Button->isChecked())
            GS_config_holder::setBackGroundType(":/eyecandy");
        if(ui.t1Button->isChecked())
            GS_config_holder::setBackGroundType(":/eyecandy/bgTheme1");
        if(ui.t2Button->isChecked())
            GS_config_holder::setBackGroundType(":/eyecandy/bgTheme2");
        if(ui.t3Button->isChecked())
            GS_config_holder::setBackGroundType(":/eyecandy/bgTheme3");
        if(ui.t4Button->isChecked())
            GS_config_holder::setBackGroundType(":/eyecandy/bgTheme4");
        if(ui.t5Button->isChecked())
            GS_config_holder::setBackGroundType(":/eyecandy/bgTheme5");
        if(ui.t6Button->isChecked())
            GS_config_holder::setBackGroundType(":/eyecandy/bgTheme6");
        if(ui.t7Button->isChecked())
            GS_config_holder::setBackGroundType(":/eyecandy/bgTheme7");
    }
    else
    {
        QString dir = ui.bgFolderLine->text();
        QFile bg1(dir + "/itemBg.png");
        QFile bg2(dir + "/itemBgA.png");
        QFile bg3(dir + "/itemBgC.png");
        QFile bg4(dir + "/itemBgCA.png");
        if(bg1.exists()&&bg2.exists()&&bg3.exists()&&bg4.exists())
            GS_config_holder::setBackGroundType(dir);
        else
        {
            QMessageBox::warning(this,tr("No theme"),
                                 tr("No background theme was found in the specified directory."));
            return;
        }
    }
    //Deco Style
    if(!ui.dtCustomBox->isChecked())
    {
        if(ui.dt0Button->isChecked())
            GS_config_holder::setDecoLineType(":/eyecandy");
        if(ui.dt1Button->isChecked())
            GS_config_holder::setDecoLineType(":/eyecandy/decoTheme1");
        if(ui.dt2Button->isChecked())
            GS_config_holder::setDecoLineType(":/eyecandy/decoTheme2");
        if(ui.dt3Button->isChecked())
            GS_config_holder::setDecoLineType(":/eyecandy/decoTheme3");
        if(ui.dt4Button->isChecked())
            GS_config_holder::setDecoLineType(":/eyecandy/decoTheme4");
        if(ui.dt5Button->isChecked())
            GS_config_holder::setDecoLineType(":/eyecandy/decoTheme5");
        if(ui.dt6Button->isChecked())
            GS_config_holder::setDecoLineType(":/eyecandy/decoTheme6");
        if(ui.dt7Button->isChecked())
            GS_config_holder::setDecoLineType(":/eyecandy/decoTheme7");
    }
    else
    {
        QString dir = ui.dtFolderLine->text();
        QFile dt(dir + "/decoration.png");
        if(dt.exists())
            GS_config_holder::setDecoLineType(dir);
        else
        {
            QMessageBox::warning(this,tr("No theme"),
                                 tr("No decoration theme was found in the specified directory."));
            return;
        }
    }
    //Albumer Options
    //ShowMenu
    if(ui.menuBox->isChecked())
        GS_config_holder::setShowMenu("true");
    else
        GS_config_holder::setShowMenu("false");
    //Main Window
    if(ui.mainColFile->isChecked())
        GS_config_holder::setCollFile("true");
    else
        GS_config_holder::setCollFile("false");
    if(ui.mainColSearch->isChecked())
        GS_config_holder::setCollSearch("true");
    else
        GS_config_holder::setCollSearch("false");
    if(ui.mainColConfig->isChecked())
        GS_config_holder::setCollConfig("true");
    else
        GS_config_holder::setCollConfig("false");
    if(ui.mainMaxi->isChecked())
        GS_config_holder::setStartMaxi("true");
    else
        GS_config_holder::setStartMaxi("false");
    //Cat View
    if(ui.colCatOpt->isChecked())
        GS_config_holder::setCatCollOptions("true");
    else
        GS_config_holder::setCatCollOptions("false");
    if(ui.colCatMark->isChecked())
        GS_config_holder::setCatCollMarkers("true");
    else
        GS_config_holder::setCatCollMarkers("false");
    if(ui.colCatShows->isChecked())
        GS_config_holder::setCatCollShows("true");
    else
        GS_config_holder::setCatCollShows("false");
    if(ui.catShowInfo->isChecked())
        GS_config_holder::setCatShowInfo("true");
    else
        GS_config_holder::setCatShowInfo("false");
    //Viewer
    if(ui.colViewEdit->isChecked())
        GS_config_holder::setViewCollEdit("true");
    else
        GS_config_holder::setViewCollEdit("false");
    if(ui.colViewFile->isChecked())
        GS_config_holder::setViewCollFile("true");
    else
        GS_config_holder::setViewCollFile("false");
    if(ui.viewFit->isChecked())
        GS_config_holder::setViewFit("true");
    else
        GS_config_holder::setViewFit("false");
    if(ui.viewMaxi->isChecked())
        GS_config_holder::setViewMaxi("true");
    else
        GS_config_holder::setViewMaxi("false");
    GS_config_holder::setQuality(ui.qualiSlider->value());
    if(ui.checkIntegratyBox->isChecked())
        GS_config_holder::setCheckOnLoad("true");
    else
        GS_config_holder::setCheckOnLoad("false");
    ui.applyButton->setEnabled(false);
    saveConfigFile();
    emit configUpdated();
}

void GS_albumer_configurator::discardClicked()
{
    close();
}

void GS_albumer_configurator::setNeedToClose()
{
    needToClose = true;
}

void GS_albumer_configurator::configChanged()
{
    ui.applyButton->setEnabled(true);
}

void GS_albumer_configurator::getBgDir()
{
    QString dir = "";
    dir = QFileDialog::getExistingDirectory(this, tr("Open Directory"),"../");
    if(dir == "")
        return;
    else
    {
        ui.bgFolderLine->setText(dir);
        ui.applyButton->setEnabled(true);
    }
}

void GS_albumer_configurator::getDtDir()
{
    QString dir = "";
    dir = QFileDialog::getExistingDirectory(this, tr("Open Directory"),"../");
    if(dir == "")
        return;
    else
    {
        ui.dtFolderLine->setText(dir);
        ui.applyButton->setEnabled(true);
    }
}

void GS_albumer_configurator::enableApplay()
{
    ui.applyButton->setEnabled(true);
}

void GS_albumer_configurator::qualiChanged(int value)
{
    ui.qualiLabel->setText(QString("%1").arg(value));
}

void GS_albumer_configurator::customBg(bool is)
{
    if(is)
    {
        ui.t0Button->setEnabled(false);
        ui.t1Button->setEnabled(false);
        ui.t2Button->setEnabled(false);
        ui.t3Button->setEnabled(false);
        ui.t4Button->setEnabled(false);
        ui.t5Button->setEnabled(false);
        ui.t6Button->setEnabled(false);
        ui.t7Button->setEnabled(false);
        ui.t0Button->setChecked(false);
        ui.t1Button->setChecked(false);
        ui.t2Button->setChecked(false);
        ui.t3Button->setChecked(false);
        ui.t4Button->setChecked(false);
        ui.t5Button->setChecked(false);
        ui.t6Button->setChecked(false);
        ui.t7Button->setChecked(false);
        ui.bgFolderLine->setEnabled(true);
        ui.bgPickFolderButton->setEnabled(true);
    }
    else
    {
        ui.t0Button->setEnabled(true);
        ui.t1Button->setEnabled(true);
        ui.t2Button->setEnabled(true);
        ui.t3Button->setEnabled(true);
        ui.t4Button->setEnabled(true);
        ui.t5Button->setEnabled(true);
        ui.t6Button->setEnabled(true);
        ui.t7Button->setEnabled(true);
        ui.bgFolderLine->setEnabled(false);
        ui.bgPickFolderButton->setEnabled(false);
    }
}

void GS_albumer_configurator::customDt(bool is)
{
    if(is)
    {

        ui.dt0Button->setEnabled(false);
        ui.dt1Button->setEnabled(false);
        ui.dt2Button->setEnabled(false);
        ui.dt3Button->setEnabled(false);
        ui.dt4Button->setEnabled(false);
        ui.dt5Button->setEnabled(false);
        ui.dt6Button->setEnabled(false);
        ui.dt7Button->setEnabled(false);
        ui.dt0Button->setChecked(false);
        ui.dt1Button->setChecked(false);
        ui.dt2Button->setChecked(false);
        ui.dt3Button->setChecked(false);
        ui.dt4Button->setChecked(false);
        ui.dt5Button->setChecked(false);
        ui.dt6Button->setChecked(false);
        ui.dt7Button->setChecked(false);
        ui.dtFolderLine->setEnabled(true);
        ui.dtPickFolderButton->setEnabled(true);
    }
    else
    {
        ui.dt0Button->setEnabled(true);
        ui.dt1Button->setEnabled(true);
        ui.dt2Button->setEnabled(true);
        ui.dt3Button->setEnabled(true);
        ui.dt4Button->setEnabled(true);
        ui.dt5Button->setEnabled(true);
        ui.dt6Button->setEnabled(true);
        ui.dt7Button->setEnabled(true);
        ui.dtFolderLine->setEnabled(false);
        ui.dtPickFolderButton->setEnabled(false);
    }
}

void GS_albumer_configurator::loadConfigFile()
{
    QStringList args = QApplication::arguments();
    QString path;
    QFileInfo dir(args.first());
    path= dir.absolutePath()+"/";
    QFile configFile(path+"Albumer.conf");
    if(!configFile.exists())
    {
        return;
    }
    configFile.open(QIODevice::ReadOnly);
    QTextStream inStream(&configFile);
    while(!inStream.atEnd())
    {
        QString line = inStream.readLine();
        if(line == "[BG]")
        {
            if(!inStream.atEnd())
                GS_config_holder::setBackGroundType(inStream.readLine());
        }
        else if(line == "[DL]")
        {
            if(!inStream.atEnd())
                GS_config_holder::setDecoLineType(inStream.readLine());
        }
        else if(line == "[MENU]")
        {
            if(!inStream.atEnd())
                GS_config_holder::setShowMenu(inStream.readLine());
        }
        else if(line == "[COLLFILE]")
        {
            if(!inStream.atEnd())
                GS_config_holder::setCollFile(inStream.readLine());
        }
        else if(line == "[COLLSEARCH]")
        {
            if(!inStream.atEnd())
                GS_config_holder::setCollSearch(inStream.readLine());
        }
        else if(line == "[COLLCONFIG]")
        {
            if(!inStream.atEnd())
                GS_config_holder::setCollConfig(inStream.readLine());
        }
        else if(line == "[STARTMAXI]")
        {
            if(!inStream.atEnd())
                GS_config_holder::setStartMaxi(inStream.readLine());
        }
        else if(line =="[CATCOLOPT]")
        {
            if(!inStream.atEnd())
                GS_config_holder::setCatCollOptions(inStream.readLine());
        }
        else if(line == "[CATCOLMARK]")
        {
            if(!inStream.atEnd())
                GS_config_holder::setCatCollMarkers(inStream.readLine());
        }
        else if(line == "[CATCOLSHOW]")
        {
            if(!inStream.atEnd())
                GS_config_holder::setCatCollShows(inStream.readLine());
        }
        else if(line == "[CATSHOWINF]")
        {
            if(!inStream.atEnd())
                GS_config_holder::setCatShowInfo(inStream.readLine());
        }
        else if(line == "[VIEWCOLEDIT]")
        {
            if(!inStream.atEnd())
                GS_config_holder::setViewCollEdit(inStream.readLine());
        }
        else if(line == "[VIEWCOLFILE]")
        {
            if(!inStream.atEnd())
                GS_config_holder::setViewCollFile(inStream.readLine());
        }
        else if(line == "[VIEWFIT]")
        {
            if(!inStream.atEnd())
                GS_config_holder::setViewFit(inStream.readLine());
        }
        else if(line == "[VIEWMAXI]")
        {
            if(!inStream.atEnd())
                GS_config_holder::setViewMaxi(inStream.readLine());
        }
        else if(line == "[QUALI]")
        {
            if(!inStream.atEnd())
                GS_config_holder::setQuality(inStream.readLine().toInt());
        }
        else if(line == "[LOADCHECK]")
        {
            if(!inStream.atEnd())
                GS_config_holder::setCheckOnLoad(inStream.readLine());
        }
    }
    configFile.close();
}

void GS_albumer_configurator::saveConfigFile()
{
    QStringList args = QApplication::arguments();
    QString path;
    if(args.count() > 1)
    {
        QFileInfo dir(args.first());
        path = dir.absolutePath()+"/";
    }
    else path = "";
    QFile configFile(path+"Albumer.conf");
    configFile.open(QIODevice::WriteOnly);
    QTextStream outStream(&configFile);
    outStream << "[BG]\n" << GS_config_holder::getBackGroundType() << "\n";
    outStream << "[DL]\n" << GS_config_holder::getDecoLineType() << "\n";
    QString state = GS_config_holder::getShowMenu() ? "true" : "false";
    outStream << "[MENU]\n" << state << "\n";
    state = GS_config_holder::getCollFile() ? "true" : "false";
    outStream << "[COLLFILE]\n" << state << "\n";
    state = GS_config_holder::getCollSearch() ? "true" : "false";
    outStream << "[COLLSEARCH]\n" << state << "\n";
    state = GS_config_holder::getCollConfig() ? "true" : "false";
    outStream << "[COLLCONFIG]\n" << state << "\n";
    state = GS_config_holder::getStartMaxi() ? "true" : "false";
    outStream << "[STARTMAXI]\n" << state << "\n";
    state = GS_config_holder::getCatCollOptions() ? "true" : "false";
    outStream << "[CATCOLOPT]\n" << state << "\n";
    state = GS_config_holder::getCatCollMarkers() ? "true" : "false";
    outStream << "[CATCOLMARK]\n" << state << "\n";
    state = GS_config_holder::getCatCollShows() ? "true" : "false";
    outStream << "[CATCOLSHOW]\n" << state << "\n";
    state = GS_config_holder::getCatShowInfo() ? "true" : "false";
    outStream << "[CATSHOWINF]\n" << state << "\n";
    state = GS_config_holder::getViewCollEdit() ? "true" : "false";
    outStream << "[VIEWCOLEDIT]\n" << state << "\n";
    state = GS_config_holder::getViewCollFile() ? "true" : "false";
    outStream << "[VIEWCOLFILE]\n" << state << "\n";
    state = GS_config_holder::getViewFit() ? "true" : "false";
    outStream << "[VIEWFIT]\n" << state << "\n";
    state = GS_config_holder::getViewMaxi() ? "true" : "false";
    outStream << "[VIEWMAXI]\n" << state << "\n";
    state = QString("%1").arg(GS_config_holder::getQuality());
    outStream << "[QUALI]\n" << state << "\n";
    state = GS_config_holder::getCheckBase() ? "true" : "false";
    outStream <<"[LOADCHECK]\n" << state << "\n";
    configFile.close();
}

GS_albumer_configurator::GS_albumer_configurator(QWidget *parent)
    :QWidget(parent)
{
    ui.setupUi(this);
    ui.applyButton->setEnabled(false);
    ui.bgFolderLine->setEnabled(false);
    ui.bgPickFolderButton->setEnabled(false);
    ui.dtFolderLine->setEnabled(false);
    ui.dtPickFolderButton->setEnabled(false);
    loadConfigFile();
    needToClose = false;
    connect(ui.applyButton,SIGNAL(clicked()),this,SLOT(applyClicked()));
    connect(ui.discardButton,SIGNAL(clicked()),this,SLOT(discardClicked()));
    connect(ui.t0Button,SIGNAL(clicked()),this,SLOT(configChanged()));
    connect(ui.t1Button,SIGNAL(clicked()),this,SLOT(configChanged()));
    connect(ui.t2Button,SIGNAL(clicked()),this,SLOT(configChanged()));
    connect(ui.t3Button,SIGNAL(clicked()),this,SLOT(configChanged()));
    connect(ui.t4Button,SIGNAL(clicked()),this,SLOT(configChanged()));
    connect(ui.t5Button,SIGNAL(clicked()),this,SLOT(configChanged()));
    connect(ui.t6Button,SIGNAL(clicked()),this,SLOT(configChanged()));
    connect(ui.t7Button,SIGNAL(clicked()),this,SLOT(configChanged()));
    connect(ui.dt0Button,SIGNAL(clicked()),this,SLOT(configChanged()));
    connect(ui.dt1Button,SIGNAL(clicked()),this,SLOT(configChanged()));
    connect(ui.dt2Button,SIGNAL(clicked()),this,SLOT(configChanged()));
    connect(ui.dt3Button,SIGNAL(clicked()),this,SLOT(configChanged()));
    connect(ui.dt4Button,SIGNAL(clicked()),this,SLOT(configChanged()));
    connect(ui.dt5Button,SIGNAL(clicked()),this,SLOT(configChanged()));
    connect(ui.dt6Button,SIGNAL(clicked()),this,SLOT(configChanged()));
    connect(ui.dt7Button,SIGNAL(clicked()),this,SLOT(configChanged()));
    connect(ui.menuBox,SIGNAL(clicked()),this,SLOT(configChanged()));
    connect(ui.mainColFile,SIGNAL(clicked()),this,SLOT(configChanged()));
    connect(ui.mainColSearch,SIGNAL(clicked()),this,SLOT(configChanged()));
    connect(ui.mainColConfig,SIGNAL(clicked()),this,SLOT(configChanged()));
    connect(ui.mainMaxi,SIGNAL(clicked()),this,SLOT(configChanged()));
    connect(ui.colCatOpt,SIGNAL(clicked()),this,SLOT(configChanged()));
    connect(ui.colCatMark,SIGNAL(clicked()),this,SLOT(configChanged()));
    connect(ui.colCatShows,SIGNAL(clicked()),this,SLOT(configChanged()));
    connect(ui.catShowInfo,SIGNAL(clicked()),this,SLOT(configChanged()));
    connect(ui.colViewEdit,SIGNAL(clicked()),this,SLOT(configChanged()));
    connect(ui.colViewFile,SIGNAL(clicked()),this,SLOT(configChanged()));
    connect(ui.viewFit,SIGNAL(clicked()),this,SLOT(configChanged()));
    connect(ui.viewMaxi,SIGNAL(clicked()),this,SLOT(configChanged()));
    connect(ui.bgCustomBox,SIGNAL(clicked(bool)),this,SLOT(customBg(bool)));
    connect(ui.dtCustomBox,SIGNAL(clicked(bool)),this,SLOT(customDt(bool)));
    connect(ui.bgPickFolderButton,SIGNAL(clicked()),this,SLOT(getBgDir()));
    connect(ui.dtPickFolderButton,SIGNAL(clicked()),this,SLOT(getDtDir()));
    connect(ui.bgFolderLine,SIGNAL(editingFinished()),
            this,SLOT(enableApplay()));
    connect(ui.dtFolderLine,SIGNAL(editingFinished()),
            this,SLOT(enableApplay()));
    connect(ui.qualiSlider,SIGNAL(valueChanged(int)),this,SLOT(qualiChanged(int)));
    connect(ui.qualiSlider,SIGNAL(sliderPressed()),this,SLOT(enableApplay()));
    connect(ui.checkIntegratyBox,SIGNAL(clicked()),this,SLOT(enableApplay()));
}
