#ifndef GS_ALBUMER_CONFIGURATOR_H
#define GS_ALBUMER_CONFIGURATOR_H

#include <QWidget>
#include <QApplication>
#include <QString>
#include <QMessageBox>
#include <QCloseEvent>
#include <QShowEvent>
#include <QFile>
#include <QFileDialog>
#include <QTextStream>
#include "ui_gs_albumer_configurator.h"
#include "gs_config_holder.h"

class GS_albumer_configurator : public QWidget
{
    Q_OBJECT
public:
    GS_albumer_configurator(QWidget *parent = 0);
    void setNeedToClose();

public slots:
    void applyClicked();
    void discardClicked();

protected:
    void closeEvent(QCloseEvent* event);
    void showEvent (QShowEvent* event );
    void loadConfigFile();
    void saveConfigFile();

protected slots:
    void customBg(bool is);
    void customDt(bool is);
    void configChanged();
    void getBgDir();
    void getDtDir();
    void enableApplay();
    void qualiChanged(int value);

signals:
    void configUpdated();

private:
    Ui::GS_albumer_configurator_ui ui;
    bool needToClose;
};

#endif // GS_ALBUMER_CONFIGURATOR_H
