#include "gs_albumer_entry_editor.h"

void GS_albumer_entry_editor::closeEvent(QCloseEvent* event)
{
    if(needToClose)
    {
        event->accept();
    }
    else
    {
        event->ignore();
        hide();
    }
}

void GS_albumer_entry_editor::setNeedToClose()
{
    needToClose = true;
}

void GS_albumer_entry_editor::setEditionData(int id,QPixmap miniature,
                                             QString name,QString dsc)
{
    currentId = id;
    ui.miniatureLabel->setPixmap(miniature);
    ui.nameLabel->setText(name);
    ui.descEdit->setText(dsc);
}

void GS_albumer_entry_editor::descTextChanged()
{
    if(ui.descEdit->toPlainText().length() > 80)
    {
        QString text = ui.descEdit->toPlainText();
        text.resize(80);
        ui.descEdit->document()->clear();
        ui.descEdit->insertPlainText(text);
        ui.descEdit->textCursor().movePosition(QTextCursor::End);
    }
}

void GS_albumer_entry_editor::cancelClicked()
{
   hide();
}

void GS_albumer_entry_editor::okClicked()
{
    emit editEntry(currentId,ui.descEdit->toPlainText());
    hide();
}

GS_albumer_entry_editor::GS_albumer_entry_editor(QWidget *parent)
    :QWidget(parent)
{
    ui.setupUi(this);
    needToClose = false;
    connect(ui.descEdit,SIGNAL(textChanged()),this,SLOT(descTextChanged()));
    connect(ui.okButton,SIGNAL(clicked()),this,SLOT(okClicked()));
    connect(ui.cancelButton,SIGNAL(clicked()),this,SLOT(cancelClicked()));
}
