#include "gs_albumer_image_mover.h"

void GS_albumer_image_mover::closeEvent(QCloseEvent*)
{
    cancelClicked();
}

void GS_albumer_image_mover::setCatalogList(QStringList catList,QString from,
                                            QList<int> items_,int view_)
{
    view = view_;
    items = items_;
    QString from_ = from;
    if(from_.length() >= 20)
    {
        from_.chop(from_.length() - 17);
        from_.append("...");
    }
    ui.sourceLabel->setText(from_);
    ui.destBox->clear();
    ui.destBox->addItems(catList);
    ui.destBox->setCurrentIndex(-1);
    selectedCatalog = "";
    oldCatalog = from;
}

QString GS_albumer_image_mover::getSelectedCatalog()
{
    return selectedCatalog;
}

QString GS_albumer_image_mover::getOldCatalog()
{
    return oldCatalog;
}

void GS_albumer_image_mover::newCatalog()
{
    QString catalogName = "";
    catalogName = QInputDialog::getText(this,tr("New catalog"),tr("Catalog name"));
    catalogName.remove("/");
    catalogName.remove("\\");
    if(catalogName.trimmed() != "")
    {
        if(catalogName.length()>30)
        {
            QMessageBox::information (this,tr("Catalog error"),tr(
                    "The given catalog name is to long. Max lenght 30."
                    ));
            newCatalog();
            return;
        }
        if(ui.destBox->findText(catalogName.trimmed())==-1)
        {
            ui.destBox->addItem(catalogName.trimmed());
            ui.destBox->setCurrentIndex(ui.destBox->findText(catalogName.trimmed()));
        }
        else
        {
            QMessageBox::information (this,tr("Catalog exists"),tr(
                    "A catalog with the given name already exists.\nIt will be selected"
                    ));
            ui.destBox->setCurrentIndex(ui.destBox->findText(catalogName.trimmed()));
        }
    }
}

void GS_albumer_image_mover::catalogListSelectionChanged(int index)
{
    if(index != -1)
    {
        selectedCatalog = ui.destBox->currentText();
    }
}

void GS_albumer_image_mover::cancelClicked()
{
    hide();
}

void GS_albumer_image_mover::okClicked()
{
    hide();
    emit catalogPicked(items,view);
}

GS_albumer_image_mover::GS_albumer_image_mover(QDialog *parent)
    :QDialog(parent)
{
    this->setWindowModality(Qt::ApplicationModal);
    ui.setupUi(this);
    connect(ui.destBox,SIGNAL(currentIndexChanged(int)),this,
            SLOT(catalogListSelectionChanged(int)));
    connect(ui.newButton,SIGNAL(clicked()),this,SLOT(newCatalog()));
    connect(ui.cancelButton,SIGNAL(clicked()),this,SLOT(cancelClicked()));
    connect(ui.okButton,SIGNAL(clicked()),this,SLOT(okClicked()));
}
