#include "gs_albumer_passer.h"

void GS_albumer_passer::closeEvent(QCloseEvent*)
{
    cancelClidked();
}

void GS_albumer_passer::keyPressEvent(QKeyEvent* event)
{
    if(event->key() == Qt::Key_Return)
        event->ignore();
}

void GS_albumer_passer::okClicked()
{
    validateEnteredPassWord();
    if(isPassOk)
    {
        emit enteredPass(true);
        hide();
    }
    else
    {
        QMessageBox::warning(this,tr("Wrong password"),
                             tr("You have entered an invalid password."));
    }
}

void GS_albumer_passer::cancelClidked()
{
    emit enteredPass(false);
    hide();
}

void GS_albumer_passer::validateEnteredPassWord()
{
    if(ui.passLine->text() == password)
        isPassOk = true;
    else
        isPassOk = false;
}

void GS_albumer_passer::setPassWord(QString passWD)
{
    password = passWD;
    ui.passLine->setText("");
}

GS_albumer_passer::GS_albumer_passer(QWidget *parent)
    :QDialog(parent)
{
    ui.setupUi(this);
    this->setWindowModality(Qt::ApplicationModal);
    connect(ui.okButton,SIGNAL(clicked()),this,SLOT(okClicked()));
    connect(ui.passLine,SIGNAL(returnPressed()),this,SLOT(okClicked()));
    connect(ui.cancelButton,SIGNAL(clicked()),this,SLOT(cancelClidked()));
}
