#ifndef GS_ALBUMER_SEARCHER_H
#define GS_ALBUMER_SEARCHER_H
#include <QCloseEvent>
#include <QStringList>
#include <QMessageBox>
#include "ui_gs_albumer_searcher.h"

class GS_albumer_searcher : public QWidget
{
    Q_OBJECT

public:
    GS_albumer_searcher(QWidget *parent = 0);
    void setNeedToClose();
    void setAuthorList(QStringList);
    QDate getFromDate();
    QDate getToDate();
    QString getAuthor();
    QStringList getNames();

signals:
    void searchReady(bool,bool,bool);

protected:
    void closeEvent(QCloseEvent* event);

private slots:
    void nameSearchChanged(int);
    void authorSearchChanged(int);
    void dateSearchChanged(int);
    void nameListSelChanged();
    void addName();
    void removeName();
    void searchClicked();
    void fromDateChanged(QDate);
    void toDateChanged(QDate);
private:
    Ui::GS_albumer_searcher_ui ui;
    bool needToClose, names, author, date;
    QStringList nameList;
};

#endif // GS_ALBUMER_SEARCHER_H
