#ifndef GS_CONFIG_HOLDER_H
#define GS_CONFIG_HOLDER_H

#include <QString>

class GS_config_holder
{
public:
    GS_config_holder();
    static void setBackGroundType(QString newBackGroundType);
    static void setDecoLineType(QString newDecoLineType);
    static void setShowMenu(QString showMenuState);
    static void setCollFile(QString collFileMenu);
    static void setCollSearch(QString collSearchMenu);
    static void setCollConfig(QString collConfigMenu);
    static void setStartMaxi(QString maxiState);
    static void setCatCollOptions(QString collOptions);
    static void setCatCollMarkers(QString collMarkers);
    static void setCatCollShows(QString collShows);
    static void setCatShowInfo(QString showInfo);
    static void setViewCollEdit(QString collapseEdit);
    static void setViewCollFile(QString collapseFile);
    static void setViewFit(QString fit);
    static void setViewMaxi(QString maxi);
    static void setQuality(int quality);
    static void setCheckOnLoad(QString check);

    static QString getBackGroundType();
    static QString getDecoLineType();
    static bool getShowMenu();
    static bool getCollFile();
    static bool getCollSearch();
    static bool getCollConfig();
    static bool getStartMaxi();
    static bool getCatCollOptions();
    static bool getCatCollMarkers();
    static bool getCatCollShows();
    static bool getCatShowInfo();
    static bool getViewCollEdit();
    static bool getViewCollFile();
    static bool getViewFit();
    static bool getViewMaxi();
    static int getQuality();
    static bool getCheckBase();

private:
    //Theme configuration
    static QString backGroundType;
    static QString decoLineType;

    //Main Window configuration
    static bool showMenu;
    static bool collapseFile;
    static bool collapseSearch;
    static bool collapseConfig;
    static bool startMaximized;

    //Catalog View configuration
    static bool collapseCatOptions;
    static bool collapseCatMarkers;
    static bool collapseCatShows;
    static bool catShowInfo;

    //Viewer configuration
    static bool collapseViewEdit;
    static bool collapseViewFile;
    static bool viewFit;
    static bool viewMaxi;

    //Base
    static int imageQuality;
    static bool checkBaseOnLoad;

};

#endif // GS_CONFIG_HOLDER_H
