#ifndef GS_view
#define GS_view
#include <QWidget>
#include <QCloseEvent>
#include <QImage>
#include <QPixmap>
#include <QMenu>
#include <QMap>
#include <QAction>
#include <QMouseEvent>
#include <QFileDialog>
#include <QImageWriter>
#include <QScrollBar>
#include <QMessageBox>
#include <QBuffer>
#include <QByteArray>
#include <QDate>
#include <QCryptographicHash>
#include "Colection/colectionManipulator.h"
#include "ui_GS_albumer_viewer.h"
#include "GS_albumer_view.h"
#include "viewer_saveas_widget.h"
#include "Colection/ImageData.h"
#include "Tools/gs_config_holder.h"
#include "Plugin/PluginManager.h"
#include "Misc/GS_albumer_progress.h"

using namespace Ui;

class GS_albumer_viewer: public GS_albumer_view
{
    Q_OBJECT
public:
    GS_albumer_viewer(ColectionManipulator* man, QWidget* parent=0);
    ~GS_albumer_viewer()
    {
        destroy(true,true);
    }
    void setImage(const QImage& image,const QString& format,int);
    bool isMyImage(int);

public slots:
    void exportImage();
    void setFit();
    void disetFit();
    void rotateClockWise();
    void rotateCClockWise();
    void vMirror();
    void hMirror();
    void historyBack();
    void historyForward();
    void saveSlot();
    void saveAsSlot();
    void applyFilter(int);
    void filterFinished();
    void filterBlock();
    void filterCancel();

signals:
    void imageChanged(int index);
    void newImageAdded(QString catalog,int index);

protected:
    void resizeEvent(QResizeEvent* event);
    void mouseReleaseEvent(QMouseEvent* event );
    void mousePressEvent(QMouseEvent* event);
    void mouseMoveEvent(QMouseEvent* event);
    void closeEvent(QCloseEvent* event);
    void keyPressEvent(QKeyEvent*);

private:
    void updateHistory();
    void updateSaveButtons();
    void updateImage();
    void createActions();
    void createMenus();
    Ui_GS_albumer_viewer_ui ui;
    QPixmap myImage;
    QString myImageFormat;
    QAction* exportAction;
    QAction* setFitAction;
    QAction* disetFitAction;
    QMenu* myMenu;
    ColectionManipulator* myManipulator;
    bool fit,drag;
    int myImageId,x,y;
    int historyIndex;
    QList<QPixmap> historyList;
    ImageFilter* currentFilter;
    GS_albumer_progress* myProgress;
};

#endif
