#ifndef MIRRORVIEWBUTTONITEM_H
#define MIRRORVIEWBUTTONITEM_H

#include <QGraphicsObject>
#include <QFontMetrics>
#include <QString>
#include <QPainter>
#include <QPixmap>
#include <QCursor>
#include <QLinearGradient>
#include <QGraphicsSceneMouseEvent>

class MirrorViewButtonItem : public QGraphicsObject
{
    Q_OBJECT
public:
    MirrorViewButtonItem(QFont font,QString buttonText);

    QRectF boundingRect() const;
    void paint(QPainter* painter,const QStyleOptionGraphicsItem* option,
               QWidget* widget);

    int getHeight() const;
    int getWidth() const;

protected:
    void hoverEnterEvent(QGraphicsSceneHoverEvent* event);
    void hoverLeaveEvent(QGraphicsSceneHoverEvent* event);
    void mousePressEvent(QGraphicsSceneMouseEvent* event);

signals:
   void clicked();

private:
   QFont myFont;
   bool touched;
   int myWidth,myHeight;
   QString myText;
};

#endif // MIRRORVIEWBUTTONITEM_H
