/*******************************************************************************
*  The design of this widget was inspired by a widget from the Fotowall project*
*                                by Enrico Ros.                                *
*                       http://code.google.com/p/fotowall                      *
*******************************************************************************/
#ifndef MYBARWIDGET_H
#define MYBARWIDGET_H

#include <QWidget>
#include <QPropertyAnimation>

class MyBarWidget : public QWidget
{
    Q_OBJECT
    Q_PROPERTY(QString title READ title WRITE setTitle)
    Q_PROPERTY(bool foldable READ isFoldable WRITE setFoldable)
    Q_PROPERTY(bool folded READ isFolded WRITE setFolded)
    Q_PROPERTY(bool leftBorder READ leftBorder WRITE setLeftBorder)
    Q_PROPERTY(bool rightBorder READ rightBorder WRITE setRightBorder)
    Q_PROPERTY(int widgetSize READ getWidgetSize WRITE setWidgetSize)
public:
    MyBarWidget(QWidget * parent = 0);
    QString title() const;
    void setTitle(const QString& title);
    bool isFoldable() const;
    void setFoldable(bool foldable);
    bool isFolded() const;
    void setFolded(bool folded);
    bool leftBorder() const;
    void setLeftBorder(bool left);
    bool rightBorder() const;
    void setRightBorder(bool right);
    int getWidgetSize() const;
    void setWidgetSize(int size);

protected:
    void enterEvent(QEvent*);
    void leaveEvent(QEvent*);
    void mousePressEvent(QMouseEvent*);
    void paintEvent(QPaintEvent* event);

private slots:
    void finishAnimation();

private:
    int minimumWidth();
    void updateFold();
    void updateMinimumHeight();
    QString myTitle;
    bool hover,fold,myFoldable,leftB,rightB,animating;
    QFont font;
    int maxHeight;
    int animationWidth;
};


#endif // MYBARWIDGET_H
