#include "gs_albumer_folder_view2.h"
void GS_albumer_folder_view2::itemClicked(int itemIndex)
{
    emit imageClicked(itemIndex);
}

void GS_albumer_folder_view2::itemRightClicked(int itemIndex,QPoint pos)
{
    rightClickedItemIndex = itemIndex;
    myItemMenu->exec(pos);
}


void GS_albumer_folder_view2::moveImage()
{
    if(rightClickedItemIndex != -1)
    {
        sentRequest = true;
        emit imageMovePicked(rightClickedItemIndex,myIndex());
        sliderValue = ui.photoView->verticalScrollBar()->value();
        rightClickedItemIndex = -1;
    }
}

void GS_albumer_folder_view2::removeImage()
{
    if(rightClickedItemIndex != -1)
    {
        sentRequest = true;
        emit imageRemovePicked(rightClickedItemIndex,myIndex());
        sliderValue = ui.photoView->verticalScrollBar()->value();
        rightClickedItemIndex = -1;
    }
}

void GS_albumer_folder_view2::exportImage()
{
    if(rightClickedItemIndex != -1)
    {
        emit imageExportPicked(rightClickedItemIndex);
        rightClickedItemIndex = -1;
    }
}

void GS_albumer_folder_view2::editDsc()
{
    if(rightClickedItemIndex != -1)
    {
        emit imageEditDscPicked(rightClickedItemIndex);
        rightClickedItemIndex = -1;
    }
}

void GS_albumer_folder_view2::removeTag()
{
    if(rightClickedItemIndex != -1)
    {
        emit removeTagPicked(rightClickedItemIndex);
        rightClickedItemIndex = -1;
    }
}

void GS_albumer_folder_view2::removeImages()
{
    if(markedItems.count() > 0)
    {
        sentRequest = true;
        emit groupRemovePicked(markedItems,myIndex());
        sliderValue = ui.photoView->verticalScrollBar()->value();
    }
}

void GS_albumer_folder_view2::moveImages()
{
    if(markedItems.count() > 0)
    {
        sentRequest = true;
        emit groupMovePicked(markedItems,myIndex());
        sliderValue = ui.photoView->verticalScrollBar()->value();
    }
}

void GS_albumer_folder_view2::exportImages()
{
    if(markedItems.count() > 0)
        emit groupExport(markedItems);
}

void GS_albumer_folder_view2::editTags()
{
    if(markedItems.count() > 0)
        emit addTags(markedItems);
}

void GS_albumer_folder_view2::nameImages()
{
    if(markedItems.count() > 0)
        emit renameImages(markedItems);
}

void GS_albumer_folder_view2::unMarkItems()
{
    for(int i =0; i < markedItems.count(); ++i)
    {
        if(itemMap.contains(markedItems.at(i)))
            itemMap.value(markedItems.at(i))->unMark();
    }
    markedItems.clear();
    ui.moveSelectedButton->setEnabled(false);
    ui.removeSelectedButton->setEnabled(false);
    ui.exportButton->setEnabled(false);
    ui.tagButton->setEnabled(false);
    ui.renameButton->setEnabled(false);
}

void GS_albumer_folder_view2::markAll()
{
    markedItems.clear();
    markedItems = itemMap.keys();
    for(int i = 0; i < markedItems.count(); ++i)
        itemMap.value(markedItems.at(i))->mark();
    ui.removeSelectedButton->setEnabled(true);
    ui.moveSelectedButton->setEnabled(true);
    ui.exportButton->setEnabled(true);
    ui.tagButton->setEnabled(true);
    ui.renameButton->setEnabled(true);
}

void GS_albumer_folder_view2::showImageInfo()
{
    if(rightClickedItemIndex != -1)
    {
        emit imageInfoShowPicked(rightClickedItemIndex);
        rightClickedItemIndex = -1;
    }
}

void GS_albumer_folder_view2::removeItem(int index,bool confermation)
{
    if(confermation)
    {
        if(itemMap.contains(index))
        {
            int temp = ui.photoView->verticalScrollBar()->value();
            scene->removeItem(itemMap.value(index));
            noPhotoItems.removeAll(itemMap.value(index));
            itemMap.erase(itemMap.find(index));
            if(itemMap.count() == 0)
            {
                closeTimer->setSingleShot(true); //hack
                closeTimer->start(50);
                return;
            }
            updateScene();
            ui.photoView->verticalScrollBar()->setValue(temp);
        }
        if(markedItems.contains(index))
        {
            markedItems.removeAt(markedItems.indexOf(index));
            if(markedItems.count() == 0)
            {
                ui.moveSelectedButton->setEnabled(false);
                ui.removeSelectedButton->setEnabled(false);
                ui.exportButton->setEnabled(false);
                ui.tagButton->setEnabled(false);
                ui.renameButton->setEnabled(false);
            }
        }
    }
    sentRequest = false;
}

void GS_albumer_folder_view2::updateTheme() const
{
    ui.photoView->scene()->update(ui.photoView->scene()->sceneRect());
}

bool GS_albumer_folder_view2::wasItMe()
{
    return sentRequest;
}

bool GS_albumer_folder_view2::isItMe(QString title_) const
{
    bool resault = false;
    if(title.trimmed() == title_.trimmed())
        resault = true;
    return resault;
}

void GS_albumer_folder_view2::resetFolderImages(QList<int> indexList)
{
    miniTimer->stop();
    noPhotoItems.clear();
    for(int i = 0; i < indexList.count(); ++i)
    {
        if(itemMap.contains(indexList.at(i)))
        {
            if(!itemMap.value(indexList.at(i))->hasMini())
                noPhotoItems.append(itemMap.value(indexList.at(i)));
        }
        else
        {
            int index = indexList.at(i);
            GS_albumer_view_item2* item =
                    new GS_albumer_view_item2(index);
            QStringList imageInfo = myManipulator->getPhotoInfo(index);
            item->setDate(imageInfo.takeLast());
            item->setName(imageInfo.takeFirst());
            itemMap[index] = item;
            noPhotoItems << item;
            connect(item,SIGNAL(iWasClicked(int)),this,SLOT(itemClicked(int)));
            connect(item,SIGNAL(iWasRightClicked(int,QPoint)),this,
                    SLOT(itemRightClicked(int,QPoint)));
            connect(item,SIGNAL(iWasMarked(int)),this,SLOT(itemMarked(int)));
            connect(item,SIGNAL(iWasUnMarked(int)),this,SLOT(itemUnMarked(int)));
            connect(item,SIGNAL(itemTouched(int)),this,SLOT(itemTouched(int)));
            connect(item,SIGNAL(itemUntouched(int)),this,SLOT(itemUntouched(int)));
        }
    }
    updateScene();
    if(noPhotoItems.count() > 0)
        miniTimer->start();
}

void GS_albumer_folder_view2::addItem(int index)
{
    miniTimer->stop();
    if(!itemMap.keys().contains(index))
    {
        GS_albumer_view_item2* item =
                new GS_albumer_view_item2(index);
        QStringList imageInfo = myManipulator->getPhotoInfo(index);
        item->setDate(imageInfo.takeLast());
        item->setName(imageInfo.takeFirst());
        itemMap[index] = item;
        noPhotoItems << item;
        connect(item,SIGNAL(iWasClicked(int)),this,SLOT(itemClicked(int)));
        connect(item,SIGNAL(iWasRightClicked(int,QPoint)),this,
                SLOT(itemRightClicked(int,QPoint)));
        connect(item,SIGNAL(iWasMarked(int)),this,SLOT(itemMarked(int)));
        connect(item,SIGNAL(iWasUnMarked(int)),this,SLOT(itemUnMarked(int)));
        connect(item,SIGNAL(itemTouched(int)),this,SLOT(itemTouched(int)));
        connect(item,SIGNAL(itemUntouched(int)),this,SLOT(itemUntouched(int)));
    }
    updateScene();
    if(noPhotoItems.count() > 0)
        miniTimer->start();
}

void GS_albumer_folder_view2::setFolderImages(QList<int> indexList,
                                              QStringList titleList,
                                              QStringList dateList,
                                              QString title_,
                                              QString catalog)
{
    if(!indexList.isEmpty())
    {
        while(!indexList.isEmpty())
        {
            int index = indexList.takeFirst();
            GS_albumer_view_item2* item =
                    new GS_albumer_view_item2(index);
            item->setDate(dateList.takeFirst());
            item->setName(titleList.takeFirst());
            itemMap[index] = item;
            noPhotoItems << item;
        }
        decoLine = new GS_albumer_deco_line2(title_);
        title = catalog;
    }
    foreach(const GS_albumer_view_item2* item, itemMap.values())
    {
        connect(item,SIGNAL(iWasClicked(int)),this,SLOT(itemClicked(int)));
        connect(item,SIGNAL(iWasRightClicked(int,QPoint)),this,
                SLOT(itemRightClicked(int,QPoint)));
        connect(item,SIGNAL(iWasMarked(int)),this,SLOT(itemMarked(int)));
        connect(item,SIGNAL(iWasUnMarked(int)),this,SLOT(itemUnMarked(int)));
        connect(item,SIGNAL(itemTouched(int)),this,SLOT(itemTouched(int)));
        connect(item,SIGNAL(itemUntouched(int)),this,SLOT(itemUntouched(int)));
    }
    if(noPhotoItems.count() > 0)
        miniTimer->start();
}

void GS_albumer_folder_view2::updateScene()
{
    int sceneHeihgt = getPhotoLineCount();
    int sceneWidth  = ui.photoView->width() - 15;
    if(sceneHeihgt < ui.photoView->height())
    {
        sceneHeihgt = ui.photoView->height();
        ui.photoView->setVerticalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
    }
    else
        ui.photoView->setVerticalScrollBarPolicy(Qt::ScrollBarAsNeeded);
    scene = new QGraphicsScene(0,0,sceneWidth,sceneHeihgt);
    ui.photoView->setScene(scene);
    scene->addItem(decoLine);
    decoLine->setPos((scene->width()/2)-300,5);
    int line = 0;
    int column = 0;
    int colItems = getWItemCount();
    int offset = ((ui.photoView->width() - (160*colItems))/2) - 3;
    QList<int> indexList = itemMap.keys();
    qSort(indexList);
    for(int i = 0; i < indexList.count(); ++i)
    {
        scene->addItem(itemMap[indexList.at(i)]);
        itemMap[indexList.at(i)]->setPos(offset+(160*column),105+(160*line));
        ++column;
        if(column == colItems)
        {
            column = 0;
            ++line;
        }
    }
    scene->addItem(infoItem);
    infoItem->hide();
}

void GS_albumer_folder_view2::itemMarked(int index)
{
    markedItems << index;
    ui.moveSelectedButton->setEnabled(true);
    ui.removeSelectedButton->setEnabled(true);
    ui.exportButton->setEnabled(true);
    ui.tagButton->setEnabled(true);
    ui.renameButton->setEnabled(true);
}

void GS_albumer_folder_view2::itemUnMarked(int index)
{
    markedItems.removeAt(markedItems.indexOf(index));
    if(markedItems.count() == 0)
    {
        ui.moveSelectedButton->setEnabled(false);
        ui.removeSelectedButton->setEnabled(false);
        ui.exportButton->setEnabled(false);
        ui.tagButton->setEnabled(false);
        ui.renameButton->setEnabled(false);
    }
}

void GS_albumer_folder_view2::itemTouched(int index)
{
    if(itemMap.keys().contains(index) && showInfo)
    {
        infoItem->setName(itemMap.value(index)->getName());
        infoItem->setDate(itemMap.value(index)->getDate());

        float posx = (itemMap.value(index)->x() + 75) -
                     (infoItem->getWidth() * 0.5f);
        if(posx + infoItem->getWidth() > scene->width())
            posx = scene->width() - infoItem->getWidth();
        if(posx < 0)
            posx = 0;
        float posy  = itemMap.value(index)->y() + 120;

        infoItem->setPos(posx,posy);
        infoItem->show();
    }
}

void GS_albumer_folder_view2::itemUntouched(int index)
{
    if(itemMap.keys().contains(index) && showInfo)
    {
        infoItem->hide();
    }
}

void GS_albumer_folder_view2::hideEvent(QHideEvent*)
{
    sliderValue = ui.photoView->verticalScrollBar()->value();
}

void GS_albumer_folder_view2::showEvent(QShowEvent*)
{
    ui.photoView->verticalScrollBar()->setValue(sliderValue);
    setFocus();
}

void GS_albumer_folder_view2::keyPressEvent(QKeyEvent* event)
{
    if(event->modifiers() == Qt::AltModifier)
    {
        switch(event->key())
        {
        case Qt::Key_T:
            editTags();
            break;
        case Qt::Key_M:
            moveImages();
            break;
        case Qt::Key_N:
            nameImages();
            break;
        case Qt::Key_E:
            exportImages();
            break;
        case Qt::Key_R:
            removeImages();
            break;
        }
    }
    else if(event->modifiers() == Qt::ShiftModifier)
    {
        switch(event->key())
        {
        case Qt::Key_M:
            mirrorView();
            break;
        case Qt::Key_S:
            slideShow();
            break;
        }
    }
    else if(event->modifiers() == Qt::ControlModifier)
    {
        switch(event->key())
        {
        case Qt::Key_A:
            markAll();
            break;
        case Qt::Key_D:
            unMarkItems();
            break;
        case Qt::Key_Q:
            close();
            break;
        }
    }
}

void GS_albumer_folder_view2::closeEvent(QCloseEvent*)
{
    this->deleteLater();
}

void GS_albumer_folder_view2::resizeEvent(QResizeEvent*)
{
    updateScene();
    if(first)
    {
        ui.photoView->ensureVisible(0,0,10,10);
        first = false;
    }
}

int GS_albumer_folder_view2::getWItemCount()
{
    int temp = ((ui.photoView->width() - 30)/160);
    return temp;
}

int GS_albumer_folder_view2::getPhotoLineCount()
{
    int temp = 100;
    int colItems = getWItemCount();
    temp += (itemMap.values().count()/colItems)*160;
    if(itemMap.values().count() % colItems != 0) temp += 160;
    return temp;
}

void GS_albumer_folder_view2::slideShow()
{
    if(markedItems.count() > 0)
        emit  startSlideShow(markedItems);
    else
        emit startSlideShow(itemMap.keys());

}

void GS_albumer_folder_view2::mirrorView()
{
    if(markedItems.count() > 0)
        emit startMirror(markedItems);
    else
        emit startMirror(itemMap.keys());
}

void GS_albumer_folder_view2::infoStateChange()
{
    showInfo = !showInfo;
    if(showInfo)
        ui.infoToggleButton->setIcon(QIcon(QPixmap(":/eyecandy/infoActive.png")));
    else
    {
        ui.infoToggleButton->setIcon(QIcon(QPixmap(":/eyecandy/infoInactive.png")));
        infoItem->hide();
    }
}

void GS_albumer_folder_view2::createActions()
{
    movePhoto = new QAction(tr("Move Photo"),this);
    connect(movePhoto,SIGNAL(triggered()),this,SLOT(moveImage()));
    removePhoto = new QAction(tr("Remove Photo"),this);
    connect(removePhoto,SIGNAL(triggered()),this,SLOT(removeImage()));
    exportPhoto = new QAction(tr("Export Photo"),this);
    connect(exportPhoto,SIGNAL(triggered()),this,SLOT(exportImage()));
    editPhotoDsc = new QAction(tr("Edit Photo Description"),this);
    connect(editPhotoDsc,SIGNAL(triggered()),this,SLOT(editDsc()));
    removePhotoTag = new QAction(tr("Remove Tag"),this);
    connect(removePhotoTag,SIGNAL(triggered()),this,SLOT(removeTag()));
    showPhotoInfo = new QAction(tr("Show Photo Information"),this);
    connect(showPhotoInfo,SIGNAL(triggered()),this,SLOT(showImageInfo()));
}

void GS_albumer_folder_view2::createMenus()
{
    myItemMenu = new QMenu(this);
    myItemMenu->addAction(movePhoto);
    myItemMenu->addAction(removePhoto);
    myItemMenu->addSeparator();
    myItemMenu->addAction(exportPhoto);
    myItemMenu->addSeparator();
    myItemMenu->addAction(editPhotoDsc);
    myItemMenu->addAction(removePhotoTag);
    myItemMenu->addAction(showPhotoInfo);
}

void GS_albumer_folder_view2::updateMiniature()
{
    if(noPhotoItems.count()>0)
    {
        GS_albumer_view_item2* item = noPhotoItems.takeFirst();
        item->setMini(QPixmap::fromImage(
                myManipulator->getPhotoMini(item->getMyIndex())));
        if(noPhotoItems.count()>0)
            miniTimer->start();
    }
}

void GS_albumer_folder_view2::updateMiniature(int index)
{
    if(itemMap.contains(index))
    {
        if(itemMap.value(index)->hasMini())
            itemMap.value(index)->setMini(QPixmap::fromImage(
                    myManipulator->getPhotoMini(index)));
    }
}

void GS_albumer_folder_view2::loadNames(QList<int> itemList)
{
    for(int i = 0; i < itemList.count(); ++i)
    {
        int index = itemList.at(i);
        if(itemMap.contains(index))
        {
            if(itemMap.value(index)->hasMini())
                itemMap.value(index)->setName(myManipulator->getPhotoName(index));
        }
    }
}

void GS_albumer_folder_view2::closeView()
{
    emit wantToClose(myIndex());
}

GS_albumer_folder_view2::GS_albumer_folder_view2(ColectionManipulator* manipulator
                                                 ,QWidget *parent)
                                                     :GS_albumer_view(parent),first(true)
{
    ui.setupUi(this);
    createActions();
    createMenus();
    static int instanceCount_ = 0;
    ++instanceCount_;
    rightClickedItemIndex = -1;
    sentRequest = false;
    sliderValue = 0;
    setIndex(instanceCount_);
    closeTimer = new QTimer(this);
    connect(closeTimer,SIGNAL(timeout()),this,SLOT(closeView()));
    setAttribute(Qt::WA_DeleteOnClose);

    miniTimer = new QTimer(this);
    miniTimer->setSingleShot(true);
    miniTimer->setInterval(5);

    myManipulator = manipulator;

    infoItem = new GS_view_info_item();
    infoItem->setZValue(1);

    showInfo = GS_config_holder::getCatShowInfo();
    if(showInfo)
        ui.infoToggleButton->setIcon(QIcon(
                QPixmap(":/eyecandy/infoActive.png")));
    else
        ui.infoToggleButton->setIcon(QIcon(
                QPixmap(":/eyecandy/infoInactive.png")));

    ui.toolOptions->setFolded(GS_config_holder::getCatCollOptions());
    ui.markOptions->setFolded(GS_config_holder::getCatCollMarkers());
    ui.viewOptions->setFolded(GS_config_holder::getCatCollShows());

    ui.slideShow->setToolTip(tr("Start slide show. (Shift+S)"));
    ui.slideShow->setStatusTip(tr("Start slide show."));
    ui.closeButton->setToolTip(tr("Close this view. (Ctrl+Q)"));
    ui.closeButton->setStatusTip(tr("Close this view."));
    ui.moveSelectedButton->setToolTip(tr("Move marked photos. (Alt+M)"));
    ui.moveSelectedButton->setStatusTip(tr("Move marked photos."));
    ui.removeSelectedButton->setToolTip(tr("Remove marked photos. (Alt+R)"));
    ui.removeSelectedButton->setStatusTip(tr("Remove marked photos."));
    ui.unMarkAllButton->setToolTip(tr("Mark all photos. (Ctrl+D)"));
    ui.unMarkAllButton->setStatusTip(tr("Mark all photos."));
    ui.markAllButton->setToolTip(tr("Unmark all photos. (Ctrl+A)"));
    ui.markAllButton->setStatusTip(tr("Unmark all photos."));
    ui.exportButton->setToolTip(tr("Export marked photos.(Alt+E)"));
    ui.exportButton->setStatusTip(tr("Export marked photos."));
    ui.tagButton->setToolTip(tr("Add a tag to marked photos. (Alt+T)"));
    ui.tagButton->setStatusTip(tr("Add a tag to marked photos."));
    ui.renameButton->setToolTip(tr("Rename marked photos. (ALT+N)"));
    ui.renameButton->setStatusTip(tr("Rename marked photos."));
    connect(ui.closeButton,SIGNAL(clicked()),this,SLOT(closeView()));
    connect(ui.slideShow,SIGNAL(clicked()),this,SLOT(slideShow()));
    connect(ui.mirrorShow,SIGNAL(clicked()),this,SLOT(mirrorView()));
    connect(ui.moveSelectedButton,SIGNAL(clicked()),this,SLOT(moveImages()));
    connect(ui.removeSelectedButton,SIGNAL(clicked()),this,SLOT(removeImages()));
    connect(ui.unMarkAllButton,SIGNAL(clicked()),this,SLOT(unMarkItems()));
    connect(ui.markAllButton,SIGNAL(clicked()),this,SLOT(markAll()));
    connect(ui.exportButton,SIGNAL(clicked()),this,SLOT(exportImages()));
    connect(ui.infoToggleButton,SIGNAL(clicked()),this,SLOT(infoStateChange()));
    connect(miniTimer,SIGNAL(timeout()),this,SLOT(updateMiniature()));
    connect(ui.tagButton,SIGNAL(clicked()),this,SLOT(editTags()));
    connect(ui.renameButton,SIGNAL(clicked()),this,SLOT(nameImages()));

}
