#ifndef GS_ALBUMER_SLIDESHOW_H
#define GS_ALBUMER_SLIDESHOW_H

#include "ui_gs_albumer_slideshow.h"
#include <QKeyEvent>
#include <QResizeEvent>
#include <QTimer>
#include <QGraphicsScene>
#include <QGraphicsPixmapItem>
#include <QMouseEvent>

class GS_albumer_slideShow : public QWidget
{
    Q_OBJECT
public:
    GS_albumer_slideShow(QWidget *parent = 0);

protected:
    void keyPressEvent(QKeyEvent* event);
    void resizeEvent(QResizeEvent* event);
    void mouseMoveEvent (QMouseEvent* event);
    void hideEvent(QHideEvent*);
    void showEvent(QShowEvent*);

public slots:
    void startShow();
    void stopShow();
    void nextPhoto();
    void prevPhoto();
    void setPhoto(QPixmap photo);
    void setPhotoList(QList<int>);
    void hideClicked();
    void scaleImage();
    void hideTools(bool);

signals:
    void giveMeThisPhoto(int);

private:
    Ui::GS_albumer_slideShow_ui ui;
    QTimer* showTimer;
    QTimer* animationTimer;
    QList<int> photoList;
    QGraphicsScene* scene;
    QGraphicsPixmapItem* item;
    QPixmap image;
    int currentIndex;
    float wPosX,wPosY;
    bool show,right;
    float stepX;
};

#endif // GS_ALBUMER_SLIDESHOW_H
