#include "gs_albumer_view_item2.h"

int GS_albumer_view_item2::getMyIndex()
{
    return myItemIndex;
}

QRectF GS_albumer_view_item2::boundingRect() const
{
    qreal penWidth = 1;
    return QRectF(0- penWidth / 2, 0 - penWidth / 2,
                  150 + penWidth / 2, 150 + penWidth / 2);
}

void GS_albumer_view_item2::paint(QPainter *painter,
                                  const QStyleOptionGraphicsItem*,QWidget*)
{
    painter->setFont(QFont("Courier",8,8));
    if(!touched)
    {
        if(!clicked)
        {
            QString bgType =
                    GS_config_holder::getBackGroundType() + "/itemBgA.png";
            painter->drawPixmap(0,0,QPixmap(bgType));
        }
        else
        {
            QString bgType =
                    GS_config_holder::getBackGroundType() + "/itemBgCA.png";
            painter->drawPixmap(0,0,QPixmap(bgType));
        }
        painter->drawPixmap(QPointF(pos,posy),myItemPixmap);
    }
    else
    {
        if(!clicked)
        {
            QString bgType =
                    GS_config_holder::getBackGroundType() + "/itemBg.png";
            painter->drawPixmap(0,0,QPixmap(bgType));
        }
        else
        {
            QString bgType =
                    GS_config_holder::getBackGroundType() + "/itemBgC.png";
            painter->drawPixmap(0,0,QPixmap(bgType));
        }
        painter->drawPixmap(QPointF(pos,posy),myItemPixmap);
    }
    if(marked)
        painter->drawPixmap(5,5,QPixmap(":/eyecandy/marker_s.png"));
    else
        painter->drawPixmap(5,5,QPixmap(":/eyecandy/unMarker_s.png"));
}

void GS_albumer_view_item2::unMark()
{
    marked = false;
    this->update();
}

void GS_albumer_view_item2::mark()
{
    marked = true;
    this->update();
}

void GS_albumer_view_item2::setName(QString name_)
{
    name = name_;
}

void GS_albumer_view_item2::setDate(QString date_)
{
    date = date_;
}

bool GS_albumer_view_item2::hasMini()
{
    return hasMiniature;
}

void GS_albumer_view_item2::setMini(QPixmap mini)
{
    myOrignalPixmap = mini;
    myItemPixmap = myOrignalPixmap.scaled
                   (scaleValue,scaleValue,Qt::KeepAspectRatio);
    hasMiniature = true;
    scaleMiniature();
    update();
}

QString GS_albumer_view_item2::getName() const
{
    return name;
}

QString GS_albumer_view_item2::getDate() const
{
    return date;
}

void GS_albumer_view_item2::hoverEnterEvent(QGraphicsSceneHoverEvent*)
{
    touched = true;
    animator->start();
    this->update();
    myEffect->setOpacity(1.0f);
    emit itemTouched(myItemIndex);
}

void GS_albumer_view_item2::hoverLeaveEvent(QGraphicsSceneHoverEvent*)
{
    emit itemUntouched(myItemIndex);
    touched = false;
    animator->start();
    this->update();
}

void GS_albumer_view_item2::mousePressEvent(QGraphicsSceneMouseEvent* event)
{
    if(event->button() == Qt::LeftButton)
    {
        if(event->modifiers() == Qt::ShiftModifier)
        {
            if(marked)
            {
                marked = false;
                emit iWasUnMarked(myItemIndex);
                this->update();
            }
            else
            {
                marked = true;
                emit iWasMarked(myItemIndex);
                this->update();
            }
        }
        event->accept();
    }
}

void GS_albumer_view_item2::mouseDoubleClickEvent(QGraphicsSceneMouseEvent* event)
{
    if(event->button() == Qt::LeftButton)
    {
        clicked = true;
        this->update();
        emit iWasClicked(myItemIndex);
        event->accept();
    }
}

void GS_albumer_view_item2::mouseMoveEvent(QGraphicsSceneMouseEvent* event)
{
    if(QLineF(event->screenPos(),event->buttonDownScreenPos(Qt::LeftButton)).length() >= QApplication::startDragDistance())
    {
        QDrag *drag = new QDrag(event->widget());
        QMimeData *mime = new QMimeData;
        drag->setMimeData(mime);
        mime->setData("GSAlbumer/photo_IdData",QByteArray::number(myItemIndex));
        QPixmap dragPixmap = myOrignalPixmap.scaled(54,54,Qt::KeepAspectRatio,
                                                    Qt::FastTransformation);
        drag->setPixmap(dragPixmap);
        drag->setHotSpot(QPoint(dragPixmap.width()/2,
                                dragPixmap.height()/2));
        drag->exec();
    }
}

void GS_albumer_view_item2::mouseReleaseEvent(QGraphicsSceneMouseEvent* event)
{
    if(event->button() == Qt::RightButton)
    {
        emit iWasRightClicked(myItemIndex,event->screenPos());
        event->accept();
    }
}

void GS_albumer_view_item2::scaleMiniature()
{
    if(touched)
    {
        if(scaleValue < 130)
        {
            ++scaleValue;
            myItemPixmap = myOrignalPixmap.scaled
                           (scaleValue,scaleValue,Qt::KeepAspectRatio);
            pos = 75 - myItemPixmap.width()*0.5;
            posy = 75 - myItemPixmap.height()*0.5;
        }
        else
        {
            scaleValue = 130;
            myItemPixmap = myOrignalPixmap.scaled
                           (scaleValue,scaleValue,Qt::KeepAspectRatio);
            pos = 75 - myItemPixmap.width()*0.5;
            posy = 75 - myItemPixmap.height()*0.5;
            animator->stop();
        }
    }
    else
    {
        if(scaleValue > 100)
        {
            --scaleValue;
            myItemPixmap = myOrignalPixmap.scaled
                           (scaleValue,scaleValue,Qt::KeepAspectRatio);
            pos = 75 - myItemPixmap.width()*0.5;
            posy = 75 - myItemPixmap.height()*0.5;
        }
        else
        {
            scaleValue = 100;
            myItemPixmap = myOrignalPixmap.scaled
                           (scaleValue,scaleValue,Qt::KeepAspectRatio);
            pos = 75 - myItemPixmap.width()*0.5;
            posy = 75 - myItemPixmap.height()*0.5;
            animator->stop();
            myEffect->setOpacity(0.85f);
        }
    }
    this->update();
}

GS_albumer_view_item2::GS_albumer_view_item2(int myItemIndex_)
        :QGraphicsObject(),myOrignalPixmap(QPixmap(":/eyecandy/noMini.png"))
        ,myItemIndex(myItemIndex_),
        touched(false),clicked(false),marked(false),hasMiniature(false),name(""),date("")
{
    this->setAcceptsHoverEvents(true);
    this->setFlags(QGraphicsItem::ItemIsSelectable);
    this->setCursor(QCursor(QPixmap(":/eyecandy/itemCoursor.png"),15,12));
    animator = new QTimer(this);
    animator->setInterval(10);
    scaleValue = 100;
    myItemPixmap = myOrignalPixmap.scaled
                   (scaleValue,scaleValue,Qt::KeepAspectRatio);
    pos = 75 - myItemPixmap.width()*0.5;
    posy = 75 - myItemPixmap.height()*0.5;
    connect(animator,SIGNAL(timeout()),this,SLOT(scaleMiniature()));
    myEffect = new QGraphicsOpacityEffect();
    myEffect->setOpacity(0.85f);
    setGraphicsEffect(myEffect);
}
