#ifndef GS_ALBUMER_VIEW_ITEM2_H
#define GS_ALBUMER_VIEW_ITEM2_H

#include <QGraphicsObject>
#include <QGraphicsSceneHoverEvent>
#include <QGraphicsSceneMouseEvent>
#include <QGraphicsOpacityEffect>
#include <QApplication>
#include <QDrag>
#include <QMimeData>
#include <QPainter>
#include <QPixmap>
#include <QCursor>
#include <QTimer>
#include "Tools/gs_config_holder.h"

class GS_albumer_view_item2 : public QGraphicsObject
{
    Q_OBJECT
public:
    GS_albumer_view_item2(int myItemIndex_);
    ~GS_albumer_view_item2()
    {
        delete myEffect;
    }

    int getMyIndex();
    QRectF boundingRect() const;
    void paint(QPainter *painter, const QStyleOptionGraphicsItem *option,
               QWidget *widget);
    void setName(QString name_);
    void setDate(QString date_);
    bool hasMini();
    void setMini(QPixmap mini);
    QString getName() const;
    QString getDate() const;

public slots:
    void scaleMiniature();
    void unMark();
    void mark();

protected:
    void hoverEnterEvent(QGraphicsSceneHoverEvent* event);
    void hoverLeaveEvent(QGraphicsSceneHoverEvent* event);
    void mousePressEvent(QGraphicsSceneMouseEvent* event);
    void mouseDoubleClickEvent(QGraphicsSceneMouseEvent* event);
    void mouseMoveEvent(QGraphicsSceneMouseEvent* event);
    void mouseReleaseEvent(QGraphicsSceneMouseEvent* event);

signals:
    void iWasClicked(int myItemIndex);
    void iWasRightClicked(int myItemIndex,QPoint pos);
    void iWasMarked(int myItemIndex);
    void iWasUnMarked(int myItemIndex);
    void itemTouched(int myItemIndex);
    void itemUntouched(int myItemIndex);

private:
    QPixmap myItemPixmap,myOrignalPixmap;
    int myItemIndex,scaleValue;
    float pos,posy;
    bool touched, clicked, marked, hasMiniature;
    QString name;
    QString date;
    QTimer* animator;
    QGraphicsOpacityEffect* myEffect;
};

#endif // GS_ALBUMER_VIEW_ITEM2_H
