#include "gs_view_info_item.h"

QRectF GS_view_info_item::boundingRect() const
{
    return QRectF(0.0f,0.0f,width,30.0f);
}

void GS_view_info_item::paint(QPainter* painter,const QStyleOptionGraphicsItem*,
                              QWidget*)
{
    painter->setFont(QFont("Courier",8));
    painter->setPen(QColor(45,88,125,155));

    float center = width * 0.5f;
    float nameWidth = myMetrics.width(displayedName);
    float dateWidth = myMetrics.width(displayedDate);
    QRectF nameRect(center - (nameWidth * 0.5f),0.0f,nameWidth,15.0f);
    QRectF dateRect(center - (dateWidth * 0.5f),15.0f,dateWidth,15.0f);

    painter->setBrush(QColor(125,168,205,155));
    painter->drawRect(nameRect);

    painter->setBrush(QColor(85,128,165,155));
    painter->drawRect(dateRect);

    painter->setPen(QColor(QColor(25,68,105)));
    painter->drawText(nameRect,displayedName);
    painter->drawText(dateRect,displayedDate);
}

void GS_view_info_item::setName(QString name)
{
    displayedName =name;
    changeWidth();
}

void GS_view_info_item::setDate(QString date)
{
    displayedDate =date;
    changeWidth();
}

void GS_view_info_item::changeWidth()
{
    if(displayedName.length() > displayedDate.length())
        width = myMetrics.width(displayedName);
    else
        width = myMetrics.width(displayedDate);
    width += 4;
}

float GS_view_info_item::getWidth() const
{
    return width;
}

GS_view_info_item::GS_view_info_item()
    :QGraphicsItem(),myMetrics(QFont("Courier",8))
{
    width = 10.0f;
    displayedName = "Name: ";
    displayedDate = "Date: ";
}
