#include "viewer_saveas_widget.h"

QString Viewer_SaveAs_Widget::getCatalog()
{
    return ui.catalogBox->currentText();
}

QString Viewer_SaveAs_Widget::getName()
{
    return ui.nameEdit->text().trimmed();
}

QString Viewer_SaveAs_Widget::getDesc()
{
    return ui.descriptionEdit->toPlainText();
}

QString Viewer_SaveAs_Widget::getAutor()
{
    return ui.authorEdit->text();
}

QString Viewer_SaveAs_Widget::getFormat()
{
    QString format = ui.formatBox->currentText().split(" ").first();
    return format;
}

void Viewer_SaveAs_Widget::okClicked()
{
    if(ui.nameEdit->text().trimmed() != "" && ui.catalogBox->currentText().trimmed() != "")
        done(1);
    else
        QMessageBox::information (this,tr("Error"),tr(
                "No name or catalog picked."));
}

void Viewer_SaveAs_Widget::cancelClicked()
{
    done(0);
}

void Viewer_SaveAs_Widget::discChanged()
{
    if(ui.descriptionEdit->toPlainText().length() > 80)
    {
        QString text = ui.descriptionEdit->toPlainText();
        text.resize(80);
        ui.descriptionEdit->document()->clear();
        ui.descriptionEdit->insertPlainText(text);
        ui.descriptionEdit->textCursor().movePosition(QTextCursor::End);
    }
}

void Viewer_SaveAs_Widget::newCatalogClicked()
{
    bool ok;
    QString temp = QInputDialog::getText(this, tr("Catalog creation"),
                                         tr("New Catalog name:"), QLineEdit::Normal,
                                         "", &ok);
    temp.remove("/");
    temp.remove("\\");
    if(ok&&temp.trimmed()!="")
    {
        if(ui.catalogBox->findText(temp)==-1)
        {
            if(temp.length()>30)
            {
                QMessageBox::information (this,tr("Catalog error"),tr(
                        "The given catalog name is to long. Max lenght 30."
                        ));
                newCatalogClicked();
                return;
            }
            ui.catalogBox->addItem(temp);
            ui.catalogBox->setCurrentIndex(ui.catalogBox->findText(temp));
        }
        else
        {
            QMessageBox::information (this,tr("Catalog exists"),tr(
                    "A catalog with the given name already exists.\nIt will be selected"
                    ));
            ui.catalogBox->setCurrentIndex(ui.catalogBox->findText(temp));
        }
    }
}

Viewer_SaveAs_Widget::Viewer_SaveAs_Widget(QStringList catalogList,QWidget *parent)
    :QDialog(parent)
{
    ui.setupUi(this);
    ui.catalogBox->addItems(catalogList);
    this->setWindowModality(Qt::ApplicationModal);
    setResult(0);
    connect(ui.cancelButton,SIGNAL(clicked()),this,SLOT(cancelClicked()));
    connect(ui.okButton,SIGNAL(clicked()),this,SLOT(okClicked()));
    connect(ui.newCatalogButton,SIGNAL(clicked()),this,SLOT(newCatalogClicked()));
    connect(ui.descriptionEdit,SIGNAL(textChanged()),this,SLOT(discChanged()));
}

Viewer_SaveAs_Widget::~Viewer_SaveAs_Widget()
{
}
